=== modified file 'DBUS-API'
--- DBUS-API	2015-05-23 20:18:34 +0000
+++ DBUS-API	2016-02-28 14:22:10 +0000
@@ -13,34 +13,25 @@
   | Path                  | Object            |
   |-----------------------+-------------------|
   | "/"                   | The Mandos Server |
-  | "/clients/CLIENTNAME" | Mandos Client     |
-
-  
+
+  (To get a list of paths to client objects, use the standard D-Bus
+  org.freedesktop.DBus.ObjectManager interface, which the server
+  object supports.)
+
+
 * Mandos Server Interface:
   Interface name: "se.recompile.Mandos"
   
 ** Methods:
-*** GetAllClients() → (ao: Clients)
-    Returns an array of all client D-Bus object paths
-   
-*** GetAllClientsWithProperties() → (a{oa{sv}}: ClientProperties)
-    Returns an array of all clients and all their properties
-   
 *** RemoveClient(o: ObjectPath) → nothing
     Removes a client
    
 ** Signals:
-*** ClientAdded(o: ObjectPath)
-    A new client was added.
-   
 *** ClientNotFound(s: Fingerprint, s: Address)
     A client connected from Address using Fingerprint, but was
     rejected because it was not found in the server.  The fingerprint
     is represented as a string of hexadecimal digits.  The address is
     an IPv4 or IPv6 address in its normal string format.
-   
-*** ClientRemoved(o: ObjectPath, s: Name)
-    A client named Name on ObjectPath was removed.
 
 
 * Mandos Client Interface:
@@ -55,20 +46,6 @@
     Assert that this client has been checked and found to be alive.
     This will restart the timeout before disabling this client.  See
     also the "LastCheckedOK" property.
-    
-*** Disable() → nothing
-    Disable this client.  See also the "Enabled" property.
-    
-*** Enable() → nothing
-    Enable this client.  See also the "Enabled" property.
-    
-*** StartChecker() → nothing
-    Start a new checker for this client, if none is currently
-    running.  See also the "CheckerRunning" property.
-    
-*** StopChecker() → nothing
-    Abort a running checker process for this client, if any.  See also
-    the "CheckerRunning" property.
 
 ** Properties
    
@@ -96,7 +73,6 @@
    | LastCheckerStatus (i)   | n    | Read       | N/A                 |
    | LastEnabled (j)         | s    | Read       | N/A                 |
    | Name                    | s    | Read       | (Section name)      |
-   | ObjectPath              | o    | Read       | N/A                 |
    | Secret (k)              | ay   | Write      | secret (or secfile) |
    | Timeout (a)             | t    | Read/Write | timeout             |
    
@@ -104,13 +80,12 @@
    
    b) An approval is currently pending.
    
-   c) Setting this property is equivalent to calling StartChecker() or
-      StopChecker().
+   c) Changing this property can either start a new checker or abort a
+      running one.
    
    d) The creation time of this client object, as an RFC 3339 string.
    
-   e) Setting this property is equivalent to calling Enable() or
-      Disable().
+   e) Changing this property enables or disables a client.
    
    f) The date and time this client will be disabled, as an RFC 3339
       string, or an empty string if this is not scheduled.
@@ -134,10 +109,10 @@
    k) A raw byte array, not hexadecimal digits.
 
 ** Signals
-*** CheckerCompleted(n: Exitcode, x: Signal, s: Command)
+*** CheckerCompleted(n: Exitcode, x: Waitstatus, s: Command)
     A checker (Command) has completed.  Exitcode is either the exit
-    code or -1 for abnormal exit, in which case, the signal number
-    is available.
+    code or -1 for abnormal exit.  In any case, the full Waitstatus
+    (as from wait(2)) is also available.
     
 *** CheckerStarted(s: Command)
     A checker command (Command) has just been started.
@@ -155,8 +130,8 @@
 
 * Copyright
 
-    Copyright © 2010-2015 Teddy Hogeborn
-    Copyright © 2010-2015 Björn Påhlsson
+    Copyright © 2010-2016 Teddy Hogeborn
+    Copyright © 2010-2016 Björn Påhlsson
   
 ** License:
    

=== modified file 'INSTALL'
--- INSTALL	2014-07-25 22:44:20 +0000
+++ INSTALL	2016-02-28 03:01:43 +0000
@@ -4,7 +4,7 @@
   
 ** Operating System
    
-   Debian 6.0 "squeeze" or Ubuntu 10.10 "Maverick Meerkat" (or later).
+   Debian 8.0 "jessie" or Ubuntu 15.10 "Wily Werewolf" (or later).
    
    This is mostly for the support scripts which make sure that the
    client is installed and started in the initial RAM disk environment
@@ -38,11 +38,9 @@
     "man -l mandos.8".
     
 *** Mandos Server
-    + GnuTLS 2.4          http://www.gnutls.org/
-      Note: GnuTLS 3 will only work with Python-GnuTLS 2
+    + GnuTLS 3.3          http://www.gnutls.org/
     + Avahi 0.6.16        http://www.avahi.org/
     + Python 2.7          https://www.python.org/
-    + Python-GnuTLS 1.1.5 https://pypi.python.org/pypi/python-gnutls/
     + dbus-python 0.82.4  http://dbus.freedesktop.org/doc/dbus-python/
     + PyGObject 2.14.2    https://developer.gnome.org/pygobject/
     + pkg-config  http://www.freedesktop.org/wiki/Software/pkg-config/
@@ -54,13 +52,13 @@
     + ssh-keyscan from OpenSSH http://www.openssh.com/
     
     Package names:
-    python-gnutls avahi-daemon python python-avahi python-dbus
-    python-gobject python-urwid pkg-config fping ssh-client
+    avahi-daemon python python-avahi python-dbus python-gobject
+    python-urwid pkg-config fping ssh-client
     
 *** Mandos Client
     + initramfs-tools 0.85i
                         https://tracker.debian.org/pkg/initramfs-tools
-    + GnuTLS 2.4        http://www.gnutls.org/
+    + GnuTLS 3.3        http://www.gnutls.org/
     + Avahi 0.6.16      http://www.avahi.org/
     + GnuPG 1.4.9       https://www.gnupg.org/
     + GPGME 1.1.6       https://www.gnupg.org/related_software/gpgme/

=== modified file 'Makefile'
--- Makefile	2014-10-05 20:08:58 +0000
+++ Makefile	2016-02-21 14:24:01 +0000
@@ -14,6 +14,24 @@
 # For info about _FORTIFY_SOURCE, see feature_test_macros(7)
 # and <http://gcc.gnu.org/ml/gcc-patches/2004-09/msg02055.html>.
 FORTIFY=-D_FORTIFY_SOURCE=2 -fstack-protector-all -fPIC
+# <https://developerblog.redhat.com/2014/10/16/gcc-undefined-behavior-sanitizer-ubsan/>
+# The sanitizing options are available in GCC 4.9 and above.
+ifeq ($(shell test $(shell $(CC) -dumpversion) \> 4.9-; echo $$?),0)
+SANITIZE:=-fsanitize=address -fsanitize=undefined -fsanitize=shift \
+	-fsanitize=integer-divide-by-zero -fsanitize=unreachable \
+	-fsanitize=vla-bound -fsanitize=null -fsanitize=return \
+	-fsanitize=signed-integer-overflow
+# GCC 5.3 has some more sanitizing options
+ifeq ($(shell test $(shell $(CC) -dumpversion) \> 5.3-; echo $$?),0)
+SANITIZE+=-fsanitize=bounds -fsanitize=alignment \
+	-fsanitize=object-size -fsanitize=float-divide-by-zero \
+	-fsanitize=float-cast-overflow -fsanitize=nonnull-attribute \
+	-fsanitize=returns-nonnull-attribute -fsanitize=bool \
+	-fsanitize=enum
+endif
+else
+SANITIZE:=
+endif
 LINK_FORTIFY_LD=-z relro -z now
 LINK_FORTIFY=
 
@@ -24,9 +42,9 @@
 endif
 #COVERAGE=--coverage
 OPTIMIZE=-Os -fno-strict-aliasing
-LANGUAGE=-std=gnu99
+LANGUAGE=-std=gnu11
 htmldir=man
-version=1.6.9
+version=1.7.1
 SED=sed
 
 USER=$(firstword $(subst :, ,$(shell getent passwd _mandos || getent passwd nobody || echo 65534)))
@@ -69,11 +87,13 @@
 GPGME_CFLAGS=$(shell gpgme-config --cflags; getconf LFS_CFLAGS)
 GPGME_LIBS=$(shell gpgme-config --libs; getconf LFS_LIBS; \
 	getconf LFS_LDFLAGS)
+LIBNL3_CFLAGS=$(shell pkg-config --cflags-only-I libnl-route-3.0)
+LIBNL3_LIBS=$(shell pkg-config --libs libnl-route-3.0)
 
 # Do not change these two
-CFLAGS+=$(WARN) $(DEBUG) $(FORTIFY) $(COVERAGE) $(OPTIMIZE) \
-	$(LANGUAGE) $(GNUTLS_CFLAGS) $(AVAHI_CFLAGS) $(GPGME_CFLAGS) \
-	-DVERSION='"$(version)"'
+CFLAGS+=$(WARN) $(DEBUG) $(FORTIFY) $(SANITIZE) $(COVERAGE) \
+	$(OPTIMIZE) $(LANGUAGE) $(GNUTLS_CFLAGS) $(AVAHI_CFLAGS) \
+	$(GPGME_CFLAGS) -DVERSION='"$(version)"'
 LDFLAGS+=-Xlinker --as-needed $(COVERAGE) $(LINK_FORTIFY) $(foreach flag,$(LINK_FORTIFY_LD),-Xlinker $(flag))
 
 # Commands to format a DocBook <refentry> document into a manual page
@@ -106,7 +126,8 @@
 PLUGINS=plugins.d/password-prompt plugins.d/mandos-client \
 	plugins.d/usplash plugins.d/splashy plugins.d/askpass-fifo \
 	plugins.d/plymouth
-CPROGS=plugin-runner $(PLUGINS)
+PLUGIN_HELPERS=plugin-helpers/mandos-client-iprouteadddel
+CPROGS=plugin-runner $(PLUGINS) $(PLUGIN_HELPERS)
 PROGS=mandos mandos-keygen mandos-ctl mandos-monitor $(CPROGS)
 DOCS=mandos.8 mandos-keygen.8 mandos-monitor.8 mandos-ctl.8 \
 	mandos.conf.5 mandos-clients.conf.5 plugin-runner.8mandos \
@@ -239,6 +260,10 @@
 	$(LINK.c) $^ -lrt $(GNUTLS_LIBS) $(AVAHI_LIBS) $(strip\
 		) $(GPGME_LIBS) $(LOADLIBES) $(LDLIBS) -o $@
 
+plugin-helpers/mandos-client-iprouteadddel: plugin-helpers/mandos-client-iprouteadddel.c
+	$(LINK.c) $(LIBNL3_CFLAGS) $^ $(LIBNL3_LIBS) $(strip\
+		) $(LOADLIBES) $(LDLIBS) -o $@
+
 .PHONY : all doc html clean distclean mostlyclean maintainer-clean \
 	check run-client run-server install install-html \
 	install-server install-client-nokey install-client uninstall \
@@ -273,6 +298,7 @@
 	@echo "###################################################################"
 # We set GNOME_KEYRING_CONTROL to block pam_gnome_keyring
 	./plugin-runner --plugin-dir=plugins.d \
+		--plugin-helper-dir=plugin-helpers \
 		--config-file=plugin-runner.conf \
 		--options-for=mandos-client:--seckey=keydir/seckey.txt,--pubkey=keydir/pubkey.txt,--network-hook-dir=network-hooks.d \
 		--env-for=mandos-client:GNOME_KEYRING_CONTROL= \
@@ -352,10 +378,12 @@
 install-client-nokey: all doc
 	install --directory $(LIBDIR)/mandos $(CONFDIR)
 	install --directory --mode=u=rwx $(KEYDIR) \
-		$(LIBDIR)/mandos/plugins.d
+		$(LIBDIR)/mandos/plugins.d \
+		$(LIBDIR)/mandos/plugin-helpers
 	if [ "$(CONFDIR)" != "$(LIBDIR)/mandos" ]; then \
 		install --mode=u=rwx \
 			--directory "$(CONFDIR)/plugins.d"; \
+		install --directory "$(CONFDIR)/plugin-helpers"; \
 	fi
 	install --mode=u=rwx,go=rx --directory \
 		"$(CONFDIR)/network-hooks.d"
@@ -381,6 +409,9 @@
 	install --mode=u=rwxs,go=rx \
 		--target-directory=$(LIBDIR)/mandos/plugins.d \
 		plugins.d/plymouth
+	install --mode=u=rwxs,go=rx \
+		--target-directory=$(LIBDIR)/mandos/plugin-helpers \
+		plugin-helpers/mandos-client-iprouteadddel
 	install initramfs-tools-hook \
 		$(INITRAMFSTOOLS)/hooks/mandos
 	install --mode=u=rw,go=r initramfs-tools-hook-conf \

=== modified file 'NEWS'
--- NEWS	2014-10-05 20:08:58 +0000
+++ NEWS	2015-10-24 17:48:13 +0000
@@ -1,6 +1,36 @@
 This NEWS file records noteworthy changes, very tersely.
 See the manual for detailed information.
 
+Version 1.7.1 (2015-10-24)
+* Client
+** Bug fix: Can now really find Mandos server even if the server has
+   an IPv6 address on a network other than the one which the Mandos
+   server is on.
+
+Version 1.7.0 (2015-08-10)
+* Server
+** Bug fix: Handle local Zeroconf service name collisions better.
+** Bug fix: Finally fix "ERROR: Child process vanished" bug.
+** Bug fix: Fix systemd service file to start server correctly.
+** Bug fix: Be compatible with old 2048-bit DSA keys.
+** The D-Bus API now provides the standard D-Bus ObjectManager
+   interface, and deprecates older functionality.  See the DBUS-API
+   file for the currently recommended API.  Note: the original API
+   still works, but is deprecated.
+* Client
+** Can now find Mandos server even if the server has an IPv6 address
+   on a network without IPv6 Router Advertisment (like if the Mandos
+   client itself is the router, or there is an IPv6 router advertising
+   a network other than the one which the Mandos server is on.)
+** Use a better value than 1024 for the default number of DH bits.
+   This better value is either provided by a DH parameters file (see
+   below) or an appropriate number of DH bits is determined based on
+   the PGP key.
+** Bug fix: mandos-keygen now generates correct output for the
+   "Checker" variable even if the SSH server on the Mandos client has
+   multiple SSH key types.
+** Can now use pre-generated Diffie-Hellman parameters from a file.
+
 Version 1.6.9 (2014-10-05)
 * Server
 ** Changed to emit standard D-Bus signal when D-Bus properties change.

=== modified file 'TODO'
--- TODO	2015-05-22 20:23:46 +0000
+++ TODO	2015-10-04 13:44:03 +0000
@@ -1,7 +1,7 @@
 -*- org -*-
 
 * GIT
-** General: [[https://www.atlassian.com/git/workflows][Git Workflows]], [[http://gitimmersion.com/][Git Immersion]], [[https://news.ycombinator.com/item?id=7036628][Simple git workflow is simple]]
+** General: [[https://www.atlassian.com/git/workflows][Git Workflows]], [[http://gitimmersion.com/][Git Immersion]], [[https://news.ycombinator.com/item?id=7036628][Simple git workflow is simple]] [[https://news.ycombinator.com/item?id=9661349][On undoing, fixing, or removing commits in git]]
 ** Intro: [[http://www.eyrie.org/~eagle/notes/debian/git.html#combine][Using Git for Debian Packaging]]
 ** Use: [[https://honk.sigxcpu.org/piki/projects/git-buildpackage/][git-buildpackage]]
 ** Migration
@@ -20,18 +20,20 @@
 * mandos-applet
 
 * mandos-client
-** TODO [#A] --dh-params=FILE
+** TODO A --server option which only adds to the server list.
+   (Unlike --connect, which implicitly disables zeroconf.)
 ** TODO [#B] Use capabilities instead of seteuid().
    https://forums.grsecurity.net/viewtopic.php?f=7&t=2522
 ** TODO [#B] Use getaddrinfo(hints=AI_NUMERICHOST) instead of inet_pton()
 ** TODO [#C] Make start_mandos_communication() take "struct server".
 ** TODO [#C] --interfaces=regex,eth*,noregex (bridge-utils-interfaces(5))
+** TODO [#C] Remove code for GNU libc < 2.15
 
 * splashy
 ** TODO [#B] use scandir(3) instead of readdir(3)
 
 * usplash (Deprecated)
-** TODO [#A] Make it work again
+** TODO [#B] Make it work again
 ** TODO [#B] use scandir(3) instead of readdir(3)
 
 * askpass-fifo
@@ -48,11 +50,9 @@
 *** Hook up stderr of plugins, buffer them, and prepend "Mandos Plugin [plugin name]"
 ** TODO [#C] use same file name rules as run-parts(8)
 ** kernel command line option for debug info
+** TODO [#C] Remove code for GNU libc < 2.15
 
 * mandos (server)
-** TODO [#B] Work around Avahi issue
-   Avahi does not announce link-local addresses if any global
-   addresses exist: http://lists.freedesktop.org/archives/avahi/2010-March/001863.html
 ** TODO [#B] --notify-command
    This would allow the mandos.service to use
    --notify-command="systemd-notify --pid READY=1"
@@ -70,16 +70,13 @@
     + Approve(False) -> Close client connection immediately
 ** TODO [#C] python-parsedatetime
 ** TODO Separate logging logic to own object
-** TODO [#A] Limit approval_delay to max gnutls/tls timeout value
+** TODO [#B] Limit approval_delay to max gnutls/tls timeout value
 ** TODO [#B] break the wait on approval_delay if connection dies
 ** TODO Generate Client.runtime_expansions from client options + extra
 ** TODO Allow %%(checker)s as a runtime expansion
 ** TODO Use python-tlslite?
 ** TODO D-Bus AddClient() method on server object
 ** TODO Use org.freedesktop.DBus.Method.NoReply annotation on async methods. :2:
-** TODO Support [[http://dbus.freedesktop.org/doc/dbus-specification.html#standard-interfaces-objectmanager][org.freedesktop.DBus.ObjectManager]] interface on server object :2:
-   Deprecate methods GetAllClients(), GetAllClientsWithProperties()
-   and signals ClientAdded and ClientRemoved.
 ** TODO Save state periodically to recover better from hard shutdowns
 ** TODO CheckerCompleted method, deprecate CheckedOK
 ** TODO Secret Service API?
@@ -125,7 +122,7 @@
 *** TODO [#C] use same file name rules as run-parts(8)
 *** TODO [#C] Do not install in initrd.img if configured not to.
     Use "/etc/initramfs-tools/hooksconf.d/mandos"?
-** TODO [#C] /etc/bash_completion.d/mandos
+** TODO [#C] $(pkg-config --variable=completionsdir bash-completion)
    From XML sources directly?
 
 * Side Stuff

=== modified file 'common.ent'
--- common.ent	2014-10-05 20:08:58 +0000
+++ common.ent	2015-10-24 17:48:13 +0000
@@ -1,3 +1,3 @@
 <?xml version="1.0" encoding="UTF-8"?>
 <!-- Edited by Makefile -->
-<!ENTITY version "1.6.9">
+<!ENTITY version "1.7.1">

=== modified file 'debian/changelog'
--- debian/changelog	2014-10-05 20:08:58 +0000
+++ debian/changelog	2015-12-05 01:29:53 +0000
@@ -1,3 +1,42 @@
+mandos (1.7.1-2) unstable; urgency=medium
+
+  * debian/control (Package: mandos/Depends): Fix "Please drop versioned
+    dependency on initscripts package" by removing initscripts dependency
+    (Closes: #804967)
+  * debian/rules (override_dh_fixperms) Fix "FTBFS when built with
+    dpkg-buildpackage -A (No such file or directory)" by splitting into
+    "override_dh_fixperms-arch" and "override_dh_fixperms-indep".
+    (Closes: #806073)
+
+ -- Teddy Hogeborn <teddy@recompile.se>  Sat, 05 Dec 2015 02:27:40 +0100
+
+mandos (1.7.1-1) unstable; urgency=medium
+
+  * New upstream release.
+
+ -- Teddy Hogeborn <teddy@recompile.se>  Sat, 24 Oct 2015 19:43:40 +0200
+
+mandos (1.7.0-1) unstable; urgency=medium
+
+  * New upstream release.
+  * debian/control (Standards-Version): Updated to "3.9.6".
+    (Build-Depends): Add "libnl-route-3-dev".
+    (Package: mandos-client/Recommends): Added "gnutls-bin | openssl" for
+    the generating of DH parameters.
+  * debian/mandos-client.README.Debian: Update example command line to use
+    new MANDOSPLUGINHELPERDIR environment variable.  Also document the new
+    dhparams.pem file.
+  * debian/mandos-client.postinst: Create DH parameters file.
+  * debian/mandos.prerm: Don't run init script, use only invoke-rc.d.
+  * debian/mandos-client.postinst: Don't use absolute paths to commands.
+  * debian/mandos-client.postrm: Don't use absolute paths to commands.
+    Also remove dhparams.pem file.
+  * debian/copyright (Copyright): Update copyright year.
+  * Upstream changed systemd service file to implicitly be of
+    "Type=dbus". (Closes: #786845)
+
+ -- Teddy Hogeborn <teddy@recompile.se>  Mon, 10 Aug 2015 22:00:29 +0200
+
 mandos (1.6.9-1) unstable; urgency=medium
 
   * New upstream release.

=== modified file 'debian/control'
--- debian/control	2014-10-08 21:03:05 +0000
+++ debian/control	2016-02-28 14:10:37 +0000
@@ -5,10 +5,11 @@
 Uploaders: Teddy Hogeborn <teddy@recompile.se>,
 	   Björn Påhlsson <belorn@recompile.se>
 Build-Depends: debhelper (>= 9), docbook-xml, docbook-xsl,
-	libavahi-core-dev, libgpgme11-dev, libgnutls28-dev
-	| gnutls-dev, xsltproc, pkg-config
-Build-Depends-Indep: systemd, python2.7, python2.7-gnutls,
-	python2.7-dbus, python2.7-avahi, python2.7-gobject
+	libavahi-core-dev, libgpgme11-dev, libgnutls28-dev (>= 3.3.0)
+	| gnutls-dev (>= 3.3.0), xsltproc, pkg-config,
+	libnl-route-3-dev
+Build-Depends-Indep: systemd, python (>= 2.7), python (<< 3),
+	python-dbus, python-avahi, python-gobject | python-gi
 Standards-Version: 3.9.6
 Vcs-Bzr: http://ftp.recompile.se/pub/mandos/trunk
 Vcs-Browser: http://bzr.recompile.se/loggerhead/mandos/trunk/files
@@ -16,11 +17,11 @@
 
 Package: mandos
 Architecture: all
-Depends: ${misc:Depends}, python (>= 2.7), python2.7, python-gnutls,
-	python2.7-gnutls, python-dbus, python2.7-dbus, python-avahi,
-	python2.7-avahi, python-gobject, python2.7-gobject,
-	avahi-daemon, adduser, python-urwid, python2.7-urwid,
-	gnupg (<< 2), initscripts (>= 2.88dsf-13.3)
+Depends: ${misc:Depends}, python (>= 2.7), python (<< 3),
+	libgnutls28-dev (>= 3.3.0) | libgnutls30 (>= 3.3.0),
+	python-dbus, python-dbus, python-avahi,
+	python-gobject | python-gi, avahi-daemon, adduser,
+	python-urwid, gnupg
 Recommends: ssh-client | fping
 Description: server giving encrypted passwords to Mandos clients
  This is the server part of the Mandos system, which allows
@@ -40,8 +41,8 @@
 Package: mandos-client
 Architecture: linux-any
 Depends: ${shlibs:Depends}, ${misc:Depends}, adduser, cryptsetup,
-	gnupg (<< 2), initramfs-tools, dpkg-dev (>=1.16.0)
-Recommends: ssh
+	initramfs-tools, dpkg-dev (>=1.16.0)
+Recommends: ssh, gnutls-bin | openssl
 Breaks: dropbear (<= 0.53.1-1)
 Enhances: cryptsetup
 Description: do unattended reboots with an encrypted root file system

=== modified file 'debian/copyright'
--- debian/copyright	2014-03-01 09:39:25 +0000
+++ debian/copyright	2016-02-28 14:22:10 +0000
@@ -4,8 +4,8 @@
 Source: <http://www.recompile.se/mandos>
 
 Files: *
-Copyright: Copyright © 2008-2014 Teddy Hogeborn
-	   Copyright © 2008-2014 Björn Påhlsson
+Copyright: Copyright © 2008-2016 Teddy Hogeborn
+	   Copyright © 2008-2016 Björn Påhlsson
 License: GPL-3+
     This program is free software: you can redistribute it and/or
     modify it under the terms of the GNU General Public License as

=== modified file 'debian/mandos-client.README.Debian'
--- debian/mandos-client.README.Debian	2013-10-28 10:04:05 +0000
+++ debian/mandos-client.README.Debian	2015-07-12 01:25:14 +0000
@@ -1,3 +1,7 @@
+This file documents the next steps to take after installation of the
+Debian package, and also contain some notes specific to the Debian
+packaging which are not also in the manual.
+
 * Adding a Client Password to the Server
   
   The server must be given a password to give back to the client on
@@ -16,6 +20,8 @@
   is possible to verify that the correct password will be received by
   this client by running the command, on the client:
   
+	MANDOSPLUGINHELPERDIR=/usr/lib/$(dpkg-architecture \
+	-qDEB_HOST_MULTIARCH)/mandos/plugin-helpers \
 	/usr/lib/$(dpkg-architecture -qDEB_HOST_MULTIARCH \
 	)/mandos/plugins.d/mandos-client \
 		--pubkey=/etc/keys/mandos/pubkey.txt \
@@ -91,4 +97,13 @@
   work, "--options-for=mandos-client:--connect=<ADDRESS>:<PORT>" needs
   to be manually added to the file "/etc/mandos/plugin-runner.conf".
 
- -- Teddy Hogeborn <teddy@recompile.se>, Mon, 28 Oct 2013 11:02:26 +0100
+* Diffie-Hellman Parameters
+
+  On installation, a file with Diffie-Hellman parameters,
+  /etc/keys/mandos/dhparams.pem, will be generated and automatically
+  installed into the initital RAM disk image and also used by the
+  Mandos Client on boot.  If different parameters are needed for
+  policy or other reasons, simply replace the existing dhparams.pem
+  file and update the initital RAM disk image.
+
+ -- Teddy Hogeborn <teddy@recompile.se>, Sun, 12 Jul 2015 03:24:24 +0200

=== modified file 'debian/mandos-client.postinst'
--- debian/mandos-client.postinst	2011-10-10 20:29:58 +0000
+++ debian/mandos-client.postinst	2015-07-12 02:08:25 +0000
@@ -20,9 +20,7 @@
 # Update the initial RAM file system image
 update_initramfs()
 {
-    if [ -x /usr/sbin/update-initramfs ]; then
-	update-initramfs -u -k all
-    fi
+    update-initramfs -u -k all
     
     if dpkg --compare-versions "$2" lt-nl "1.0.10-1"; then
         # Make old initrd.img files unreadable too, in case they were
@@ -58,15 +56,39 @@
 	-a -r /etc/keys/mandos/seckey.txt ]; then
 	return 0
     fi
-    if [ -x /usr/sbin/mandos-keygen ]; then
-	mandos-keygen
-    fi
+    mandos-keygen
+}
+
+create_dh_params(){
+    if [ -r /etc/keys/mandos/dhparams.pem ]; then
+	return 0
+    fi
+    # Create a Diffe-Hellman parameters file
+    DHFILE="`mktemp -t mandos-client-dh-parameters.XXXXXXXXXX.pem`"
+    # First try certtool from GnuTLS
+    if ! certtool --generate-dh-params --sec-param high \
+	 --outfile "$DHFILE"; then
+	# Otherwise try OpenSSL
+	if ! openssl genpkey -genparam -algorithm DH -out "$DHFILE" \
+	     -pkeyopt dh_paramgen_prime_len:3072; then
+	    # None of the commands succeded; give up
+	    rm -- "$DHFILE"
+	    return 1
+	fi
+    fi
+    sed --in-place --expression='0,/^-----BEGIN DH PARAMETERS-----$/d' \
+	"$DHFILE"
+    sed --in-place --expression='1i-----BEGIN DH PARAMETERS-----' \
+	    "$DHFILE"
+    cp --archive "$DHFILE" /etc/keys/mandos/dhparams.pem
+    rm -- "$DHFILE"
 }
 
 case "$1" in
     configure)
 	add_mandos_user "$@"
 	create_key "$@"
+	create_dh_params "$@" || :
 	update_initramfs "$@"
 	;;
     abort-upgrade|abort-deconfigure|abort-remove)

=== modified file 'debian/mandos-client.postrm'
--- debian/mandos-client.postrm	2011-10-10 20:29:58 +0000
+++ debian/mandos-client.postrm	2015-07-27 09:23:56 +0000
@@ -31,9 +31,7 @@
 # Update the initial RAM file system image
 update_initramfs()
 {
-    if [ -x /usr/sbin/update-initramfs ]; then
-	update-initramfs -u -k all
-    fi
+    update-initramfs -u -k all || :
 }
 
 case "$1" in
@@ -45,7 +43,8 @@
 	shred --remove /etc/keys/mandos/seckey.txt 2>/dev/null || :
 	rm --force /etc/mandos/plugin-runner.conf \
 	    /etc/keys/mandos/pubkey.txt \
-	    /etc/keys/mandos/seckey.txt 2>/dev/null
+	    /etc/keys/mandos/seckey.txt \
+	    /etc/keys/mandos/dhparams.pem 2>/dev/null
 	update_initramfs
 	;;
     upgrade|failed-upgrade|disappear|abort-install|abort-upgrade)

=== modified file 'debian/mandos.prerm'
--- debian/mandos.prerm	2011-10-10 20:29:58 +0000
+++ debian/mandos.prerm	2015-07-12 01:57:54 +0000
@@ -17,13 +17,7 @@
 
 case "$1" in
     remove|deconfigure)
-	if [ -x /etc/init.d/mandos ]; then
-		if [ -x /usr/sbin/invoke-rc.d ]; then
-			invoke-rc.d mandos stop
-		else
-			/etc/init.d/mandos stop
-		fi
-	fi
+	invoke-rc.d mandos stop || :
 	;;
     upgrade|failed-upgrade)
         ;;

=== modified file 'debian/rules'
--- debian/rules	2014-05-12 21:02:38 +0000
+++ debian/rules	2015-12-03 21:06:34 +0000
@@ -19,13 +19,15 @@
 	$(MAKE) DESTDIR=$(CURDIR)/debian/mandos-client \
 		install-client-nokey
 
-override_dh_fixperms:
+override_dh_fixperms-arch:
 	dh_fixperms --exclude etc/keys/mandos \
-		--exclude etc/mandos/clients.conf \
 		--exclude etc/mandos/plugins.d \
 		--exclude usr/lib/$(shell dpkg-architecture -qDEB_HOST_MULTIARCH 2>/dev/null)/mandos/plugins.d \
 		--exclude usr/share/doc/mandos-client/examples/network-hooks.d
 	chmod --recursive g-w -- \
 	"$(CURDIR)/debian/mandos-client/usr/share/doc/mandos-client/examples/network-hooks.d"
 
+override_dh_fixperms-indep:
+	dh_fixperms --exclude etc/mandos/clients.conf
+
 override_dh_auto_test-arch: ;

=== modified file 'initramfs-tools-hook'
--- initramfs-tools-hook	2014-07-16 23:44:54 +0000
+++ initramfs-tools-hook	2015-10-04 13:44:03 +0000
@@ -70,11 +70,13 @@
 CONFDIR="/conf/conf.d/mandos"
 MANDOSDIR="/lib/mandos"
 PLUGINDIR="${MANDOSDIR}/plugins.d"
+PLUGINHELPERDIR="${MANDOSDIR}/plugin-helpers"
 HOOKDIR="${MANDOSDIR}/network-hooks.d"
 
 # Make directories
 install --directory --mode=u=rwx,go=rx "${DESTDIR}${CONFDIR}" \
-	"${DESTDIR}${MANDOSDIR}" "${DESTDIR}${HOOKDIR}"
+	"${DESTDIR}${MANDOSDIR}" "${DESTDIR}${HOOKDIR}" \
+	"${DESTDIR}${PLUGINHELPERDIR}"
 install --owner=${mandos_user} --group=${mandos_group} --directory \
     --mode=u=rwx "${DESTDIR}${PLUGINDIR}"
 
@@ -98,6 +100,21 @@
     esac
 done
 
+# Copy the packaged plugin helpers
+for file in "$libdir"/mandos/plugin-helpers/*; do
+    base="`basename \"$file\"`"
+    # Is this plugin overridden?
+    if [ -e "/etc/mandos/plugin-helpers/$base" ]; then
+	continue
+    fi
+    case "$base" in
+	*~|.*|\#*\#|*.dpkg-old|*.dpkg-bak|*.dpkg-new|*.dpkg-divert)
+	    : ;;
+	"*") : ;;
+	*) copy_exec "$file" "${PLUGINHELPERDIR}" ;;
+    esac
+done
+
 # Copy any user-supplied plugins
 for file in /etc/mandos/plugins.d/*; do
     base="`basename \"$file\"`"
@@ -109,6 +126,17 @@
     esac
 done
 
+# Copy any user-supplied plugin helpers
+for file in /etc/mandos/plugin-helpers/*; do
+    base="`basename \"$file\"`"
+    case "$base" in
+	*~|.*|\#*\#|*.dpkg-old|*.dpkg-bak|*.dpkg-new|*.dpkg-divert)
+	    : ;;
+	"*") : ;;
+	*) copy_exec "$file" "${PLUGINHELPERDIR}" ;;
+    esac
+done
+
 # Get DEVICE from initramfs.conf and other files
 . /etc/initramfs-tools/initramfs.conf
 for conf in /etc/initramfs-tools/conf.d/*; do
@@ -191,10 +219,24 @@
     if [ -d "$file" ]; then
 	continue
     fi
-    cp --archive --sparse=always "$file" "${DESTDIR}${CONFDIR}"
-    chown ${mandos_user}:${mandos_group} \
-	"${DESTDIR}${CONFDIR}/`basename \"$file\"`"
+    case "$file" in
+	*~|.*|\#*\#|*.dpkg-old|*.dpkg-bak|*.dpkg-new|*.dpkg-divert)
+	    : ;;
+	"*") : ;;
+	*)
+	    cp --archive --sparse=always "$file" \
+	       "${DESTDIR}${CONFDIR}"
+	    chown ${mandos_user}:${mandos_group} \
+		  "${DESTDIR}${CONFDIR}/`basename \"$file\"`"
+	    ;;
+    esac
 done
+# Use Diffie-Hellman parameters file if available
+if [ -e "${DESTDIR}${CONFDIR}"/dhparams.pem ]; then
+    sed --in-place \
+	--expression="1i--options-for=mandos-client:--dh-params=${CONFDIR}/dhparams.pem" \
+	"${DESTDIR}/${CONFDIR}/plugin-runner.conf"
+fi
 
 # /lib/mandos/plugin-runner will drop priviliges, but needs access to
 # its plugin directory and its config file.  However, since almost all
@@ -224,7 +266,7 @@
 done
 for dir in "${DESTDIR}"/lib* "${DESTDIR}"/usr/lib*; do
     if [ -d "$dir" ]; then
-	find "$dir" \! -perm -u+rw,g+r -prune -or -print0 \
-	    | xargs --null --no-run-if-empty chmod a+rX
+	find "$dir" \! -perm -u+rw,g+r -prune -or \! -type l -print0 \
+	    | xargs --null --no-run-if-empty chmod a+rX --
     fi
 done

=== modified file 'intro.xml'
--- intro.xml	2015-03-10 18:03:38 +0000
+++ intro.xml	2016-02-28 14:22:10 +0000
@@ -1,7 +1,7 @@
 <?xml version="1.0" encoding="UTF-8"?>
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 "http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
-<!ENTITY TIMESTAMP "2015-03-08">
+<!ENTITY TIMESTAMP "2016-02-28">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -32,6 +32,10 @@
     <copyright>
       <year>2011</year>
       <year>2012</year>
+      <year>2013</year>
+      <year>2014</year>
+      <year>2015</year>
+      <year>2016</year>
       <holder>Teddy Hogeborn</holder>
       <holder>Björn Påhlsson</holder>
     </copyright>

=== modified file 'mandos'
--- mandos	2015-05-23 20:18:34 +0000
+++ mandos	2016-02-28 14:22:10 +0000
@@ -1,4 +1,4 @@
-#!/usr/bin/python2.7
+#!/usr/bin/python
 # -*- mode: python; coding: utf-8 -*-
 # 
 # Mandos server - give out binary blobs to connecting clients.
@@ -11,8 +11,8 @@
 # "AvahiService" class, and some lines in "main".
 # 
 # Everything else is
-# Copyright © 2008-2015 Teddy Hogeborn
-# Copyright © 2008-2015 Björn Påhlsson
+# Copyright © 2008-2016 Teddy Hogeborn
+# Copyright © 2008-2016 Björn Påhlsson
 # 
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -44,12 +44,6 @@
 import argparse
 import datetime
 import errno
-import gnutls.crypto
-import gnutls.connection
-import gnutls.errors
-import gnutls.library.functions
-import gnutls.library.constants
-import gnutls.library.types
 try:
     import ConfigParser as configparser
 except ImportError:
@@ -78,6 +72,7 @@
 import tempfile
 import itertools
 import collections
+import codecs
 
 import dbus
 import dbus.service
@@ -103,7 +98,7 @@
 if sys.version_info.major == 2:
     str = unicode
 
-version = "1.6.9"
+version = "1.7.1"
 stored_state_file = "clients.pickle"
 
 logger = logging.getLogger()
@@ -156,8 +151,19 @@
     
     def __init__(self):
         self.tempdir = tempfile.mkdtemp(prefix="mandos-")
+        self.gpg = "gpg"
+        try:
+            output = subprocess.check_output(["gpgconf"])
+            for line in output.splitlines():
+                name, text, path = line.split(":")
+                if name == "gpg":
+                    self.gpg = path
+                    break
+        except OSError as e:
+            if e.errno != errno.ENOENT:
+                raise
         self.gnupgargs = ['--batch',
-                          '--home', self.tempdir,
+                          '--homedir', self.tempdir,
                           '--force-mdc',
                           '--quiet',
                           '--no-use-agent']
@@ -202,7 +208,7 @@
                 dir=self.tempdir) as passfile:
             passfile.write(passphrase)
             passfile.flush()
-            proc = subprocess.Popen(['gpg', '--symmetric',
+            proc = subprocess.Popen([self.gpg, '--symmetric',
                                      '--passphrase-file',
                                      passfile.name]
                                     + self.gnupgargs,
@@ -220,7 +226,7 @@
                 dir = self.tempdir) as passfile:
             passfile.write(passphrase)
             passfile.flush()
-            proc = subprocess.Popen(['gpg', '--decrypt',
+            proc = subprocess.Popen([self.gpg, '--decrypt',
                                      '--passphrase-file',
                                      passfile.name]
                                     + self.gnupgargs,
@@ -394,7 +400,18 @@
                     logger.error(bad_states[state] + ": %r", error)
             self.cleanup()
         elif state == avahi.SERVER_RUNNING:
-            self.add()
+            try:
+                self.add()
+            except dbus.exceptions.DBusException as error:
+                if (error.get_dbus_name()
+                    == "org.freedesktop.Avahi.CollisionError"):
+                    logger.info("Local Zeroconf service name"
+                                " collision.")
+                    return self.rename(remove=False)
+                else:
+                    logger.critical("D-Bus Exception", exc_info=error)
+                    self.cleanup()
+                    os._exit(1)
         else:
             if error is None:
                 logger.debug("Unknown state: %r", state)
@@ -423,14 +440,269 @@
             .format(self.name)))
         return ret
 
-def subprocess_call_pipe(connection, # : multiprocessing.Connection
-                         *args, **kwargs):
+# Pretend that we have a GnuTLS module
+class GnuTLS(object):
+    """This isn't so much a class as it is a module-like namespace.
+    It is instantiated once, and simulates having a GnuTLS module."""
+    
+    _library = ctypes.cdll.LoadLibrary(
+        ctypes.util.find_library("gnutls"))
+    _need_version = "3.3.0"
+    def __init__(self):
+        # Need to use class name "GnuTLS" here, since this method is
+        # called before the assignment to the "gnutls" global variable
+        # happens.
+        if GnuTLS.check_version(self._need_version) is None:
+            raise GnuTLS.Error("Needs GnuTLS {} or later"
+                               .format(self._need_version))
+    
+    # Unless otherwise indicated, the constants and types below are
+    # all from the gnutls/gnutls.h C header file.
+    
+    # Constants
+    E_SUCCESS = 0
+    E_INTERRUPTED = -52
+    E_AGAIN = -28
+    CRT_OPENPGP = 2
+    CLIENT = 2
+    SHUT_RDWR = 0
+    CRD_CERTIFICATE = 1
+    E_NO_CERTIFICATE_FOUND = -49
+    OPENPGP_FMT_RAW = 0         # gnutls/openpgp.h
+    
+    # Types
+    class session_int(ctypes.Structure):
+        _fields_ = []
+    session_t = ctypes.POINTER(session_int)
+    class certificate_credentials_st(ctypes.Structure):
+        _fields_ = []
+    certificate_credentials_t = ctypes.POINTER(
+        certificate_credentials_st)
+    certificate_type_t = ctypes.c_int
+    class datum_t(ctypes.Structure):
+        _fields_ = [('data', ctypes.POINTER(ctypes.c_ubyte)),
+                    ('size', ctypes.c_uint)]
+    class openpgp_crt_int(ctypes.Structure):
+        _fields_ = []
+    openpgp_crt_t = ctypes.POINTER(openpgp_crt_int)
+    openpgp_crt_fmt_t = ctypes.c_int # gnutls/openpgp.h
+    log_func = ctypes.CFUNCTYPE(None, ctypes.c_int, ctypes.c_char_p)
+    credentials_type_t = ctypes.c_int # 
+    transport_ptr_t = ctypes.c_void_p
+    close_request_t = ctypes.c_int
+    
+    # Exceptions
+    class Error(Exception):
+        # We need to use the class name "GnuTLS" here, since this
+        # exception might be raised from within GnuTLS.__init__,
+        # which is called before the assignment to the "gnutls"
+        # global variable has happened.
+        def __init__(self, message = None, code = None, args=()):
+            # Default usage is by a message string, but if a return
+            # code is passed, convert it to a string with
+            # gnutls.strerror()
+            self.code = code
+            if message is None and code is not None:
+                message = GnuTLS.strerror(code)
+            return super(GnuTLS.Error, self).__init__(
+                message, *args)
+    
+    class CertificateSecurityError(Error):
+        pass
+    
+    # Classes
+    class Credentials(object):
+        def __init__(self):
+            self._c_object = gnutls.certificate_credentials_t()
+            gnutls.certificate_allocate_credentials(
+                ctypes.byref(self._c_object))
+            self.type = gnutls.CRD_CERTIFICATE
+        
+        def __del__(self):
+            gnutls.certificate_free_credentials(self._c_object)
+    
+    class ClientSession(object):
+        def __init__(self, socket, credentials = None):
+            self._c_object = gnutls.session_t()
+            gnutls.init(ctypes.byref(self._c_object), gnutls.CLIENT)
+            gnutls.set_default_priority(self._c_object)
+            gnutls.transport_set_ptr(self._c_object, socket.fileno())
+            gnutls.handshake_set_private_extensions(self._c_object,
+                                                    True)
+            self.socket = socket
+            if credentials is None:
+                credentials = gnutls.Credentials()
+            gnutls.credentials_set(self._c_object, credentials.type,
+                                   ctypes.cast(credentials._c_object,
+                                               ctypes.c_void_p))
+            self.credentials = credentials
+        
+        def __del__(self):
+            gnutls.deinit(self._c_object)
+        
+        def handshake(self):
+            return gnutls.handshake(self._c_object)
+        
+        def send(self, data):
+            data = bytes(data)
+            data_len = len(data)
+            while data_len > 0:
+                data_len -= gnutls.record_send(self._c_object,
+                                               data[-data_len:],
+                                               data_len)
+        
+        def bye(self):
+            return gnutls.bye(self._c_object, gnutls.SHUT_RDWR)
+    
+    # Error handling functions
+    def _error_code(result):
+        """A function to raise exceptions on errors, suitable
+        for the 'restype' attribute on ctypes functions"""
+        if result >= 0:
+            return result
+        if result == gnutls.E_NO_CERTIFICATE_FOUND:
+            raise gnutls.CertificateSecurityError(code = result)
+        raise gnutls.Error(code = result)
+    
+    def _retry_on_error(result, func, arguments):
+        """A function to retry on some errors, suitable
+        for the 'errcheck' attribute on ctypes functions"""
+        while result < 0:
+            if result not in (gnutls.E_INTERRUPTED, gnutls.E_AGAIN):
+                return _error_code(result)
+            result = func(*arguments)
+        return result
+    
+    # Unless otherwise indicated, the function declarations below are
+    # all from the gnutls/gnutls.h C header file.
+    
+    # Functions
+    priority_set_direct = _library.gnutls_priority_set_direct
+    priority_set_direct.argtypes = [session_t, ctypes.c_char_p,
+                                    ctypes.POINTER(ctypes.c_char_p)]
+    priority_set_direct.restype = _error_code
+    
+    init = _library.gnutls_init
+    init.argtypes = [ctypes.POINTER(session_t), ctypes.c_int]
+    init.restype = _error_code
+    
+    set_default_priority = _library.gnutls_set_default_priority
+    set_default_priority.argtypes = [session_t]
+    set_default_priority.restype = _error_code
+    
+    record_send = _library.gnutls_record_send
+    record_send.argtypes = [session_t, ctypes.c_void_p,
+                            ctypes.c_size_t]
+    record_send.restype = ctypes.c_ssize_t
+    record_send.errcheck = _retry_on_error
+    
+    certificate_allocate_credentials = (
+        _library.gnutls_certificate_allocate_credentials)
+    certificate_allocate_credentials.argtypes = [
+        ctypes.POINTER(certificate_credentials_t)]
+    certificate_allocate_credentials.restype = _error_code
+    
+    certificate_free_credentials = (
+        _library.gnutls_certificate_free_credentials)
+    certificate_free_credentials.argtypes = [certificate_credentials_t]
+    certificate_free_credentials.restype = None
+    
+    handshake_set_private_extensions = (
+        _library.gnutls_handshake_set_private_extensions)
+    handshake_set_private_extensions.argtypes = [session_t,
+                                                 ctypes.c_int]
+    handshake_set_private_extensions.restype = None
+    
+    credentials_set = _library.gnutls_credentials_set
+    credentials_set.argtypes = [session_t, credentials_type_t,
+                                ctypes.c_void_p]
+    credentials_set.restype = _error_code
+    
+    strerror = _library.gnutls_strerror
+    strerror.argtypes = [ctypes.c_int]
+    strerror.restype = ctypes.c_char_p
+    
+    certificate_type_get = _library.gnutls_certificate_type_get
+    certificate_type_get.argtypes = [session_t]
+    certificate_type_get.restype = _error_code
+    
+    certificate_get_peers = _library.gnutls_certificate_get_peers
+    certificate_get_peers.argtypes = [session_t,
+                                      ctypes.POINTER(ctypes.c_uint)]
+    certificate_get_peers.restype = ctypes.POINTER(datum_t)
+    
+    global_set_log_level = _library.gnutls_global_set_log_level
+    global_set_log_level.argtypes = [ctypes.c_int]
+    global_set_log_level.restype = None
+    
+    global_set_log_function = _library.gnutls_global_set_log_function
+    global_set_log_function.argtypes = [log_func]
+    global_set_log_function.restype = None
+    
+    deinit = _library.gnutls_deinit
+    deinit.argtypes = [session_t]
+    deinit.restype = None
+    
+    handshake = _library.gnutls_handshake
+    handshake.argtypes = [session_t]
+    handshake.restype = _error_code
+    handshake.errcheck = _retry_on_error
+    
+    transport_set_ptr = _library.gnutls_transport_set_ptr
+    transport_set_ptr.argtypes = [session_t, transport_ptr_t]
+    transport_set_ptr.restype = None
+    
+    bye = _library.gnutls_bye
+    bye.argtypes = [session_t, close_request_t]
+    bye.restype = _error_code
+    bye.errcheck = _retry_on_error
+    
+    check_version = _library.gnutls_check_version
+    check_version.argtypes = [ctypes.c_char_p]
+    check_version.restype = ctypes.c_char_p
+    
+    # All the function declarations below are from gnutls/openpgp.h
+    
+    openpgp_crt_init = _library.gnutls_openpgp_crt_init
+    openpgp_crt_init.argtypes = [ctypes.POINTER(openpgp_crt_t)]
+    openpgp_crt_init.restype = _error_code
+    
+    openpgp_crt_import = _library.gnutls_openpgp_crt_import
+    openpgp_crt_import.argtypes = [openpgp_crt_t,
+                                   ctypes.POINTER(datum_t),
+                                   openpgp_crt_fmt_t]
+    openpgp_crt_import.restype = _error_code
+    
+    openpgp_crt_verify_self = _library.gnutls_openpgp_crt_verify_self
+    openpgp_crt_verify_self.argtypes = [openpgp_crt_t, ctypes.c_uint,
+                                        ctypes.POINTER(ctypes.c_uint)]
+    openpgp_crt_verify_self.restype = _error_code
+    
+    openpgp_crt_deinit = _library.gnutls_openpgp_crt_deinit
+    openpgp_crt_deinit.argtypes = [openpgp_crt_t]
+    openpgp_crt_deinit.restype = None
+    
+    openpgp_crt_get_fingerprint = (
+        _library.gnutls_openpgp_crt_get_fingerprint)
+    openpgp_crt_get_fingerprint.argtypes = [openpgp_crt_t,
+                                            ctypes.c_void_p,
+                                            ctypes.POINTER(
+                                                ctypes.c_size_t)]
+    openpgp_crt_get_fingerprint.restype = _error_code
+    
+    # Remove non-public functions
+    del _error_code, _retry_on_error
+# Create the global "gnutls" object, simulating a module
+gnutls = GnuTLS()
+
+def call_pipe(connection,       # : multiprocessing.Connection
+              func, *args, **kwargs):
     """This function is meant to be called by multiprocessing.Process
     
-    This function runs a synchronous subprocess.call(), and writes the
-    resulting return code on the provided multiprocessing.Connection.
+    This function runs func(*args, **kwargs), and writes the resulting
+    return value on the provided multiprocessing.Connection.
     """
-    connection.send(subprocess.call(*args, **kwargs))
+    connection.send(func(*args, **kwargs))
     connection.close()
 
 class Client(object):
@@ -645,12 +917,12 @@
         # Also start a new checker *right now*.
         self.start_checker()
     
-    def checker_callback(self, source, condition,
-                         (connection, command)):
+    def checker_callback(self, source, condition, connection,
+                         command):
         """The checker has completed, so take appropriate actions."""
         self.checker_callback_tag = None
         self.checker = None
-        # Read return code from connection (see subprocess_call_pipe)
+        # Read return code from connection (see call_pipe)
         returncode = connection.recv()
         connection.close()
         
@@ -740,14 +1012,15 @@
                 and self.server_settings["foreground"]):
                 popen_args.update({"stdout": wnull,
                                    "stderr": wnull })
-            pipe = multiprocessing.Pipe(duplex=False)
+            pipe = multiprocessing.Pipe(duplex = False)
             self.checker = multiprocessing.Process(
-                target=subprocess_call_pipe, args=(pipe[1], command),
-                kwargs=popen_args)
+                target = call_pipe,
+                args = (pipe[1], subprocess.call, command),
+                kwargs = popen_args)
             self.checker.start()
             self.checker_callback_tag = gobject.io_add_watch(
                 pipe[0].fileno(), gobject.IO_IN,
-                self.checker_callback, (pipe[0], command))
+                self.checker_callback, pipe[0], command)
         # Re-run this periodically if run by gobject.timeout_add
         return True
     
@@ -829,6 +1102,8 @@
                            access="r")
     def Property_dbus_property(self):
         return dbus.Boolean(False)
+    
+    See also the DBusObjectWithAnnotations class.
     """
     
     def decorator(func):
@@ -856,12 +1131,11 @@
     pass
 
 
-class DBusObjectWithProperties(dbus.service.Object):
-    """A D-Bus object with properties.
+class DBusObjectWithAnnotations(dbus.service.Object):
+    """A D-Bus object with annotations.
     
-    Classes inheriting from this can use the dbus_service_property
-    decorator to expose methods as D-Bus properties.  It exposes the
-    standard Get(), Set(), and GetAll() methods on the D-Bus.
+    Classes inheriting from this can use the dbus_annotations
+    decorator to add annotations to methods or signals.
     """
     
     @staticmethod
@@ -883,6 +1157,77 @@
                 for name, athing in
                 inspect.getmembers(cls, self._is_dbus_thing(thing)))
     
+    @dbus.service.method(dbus.INTROSPECTABLE_IFACE,
+                         out_signature = "s",
+                         path_keyword = 'object_path',
+                         connection_keyword = 'connection')
+    def Introspect(self, object_path, connection):
+        """Overloading of standard D-Bus method.
+        
+        Inserts annotation tags on methods and signals.
+        """
+        xmlstring = dbus.service.Object.Introspect(self, object_path,
+                                                   connection)
+        try:
+            document = xml.dom.minidom.parseString(xmlstring)
+            
+            for if_tag in document.getElementsByTagName("interface"):
+                # Add annotation tags
+                for typ in ("method", "signal"):
+                    for tag in if_tag.getElementsByTagName(typ):
+                        annots = dict()
+                        for name, prop in (self.
+                                           _get_all_dbus_things(typ)):
+                            if (name == tag.getAttribute("name")
+                                and prop._dbus_interface
+                                == if_tag.getAttribute("name")):
+                                annots.update(getattr(
+                                    prop, "_dbus_annotations", {}))
+                        for name, value in annots.items():
+                            ann_tag = document.createElement(
+                                "annotation")
+                            ann_tag.setAttribute("name", name)
+                            ann_tag.setAttribute("value", value)
+                            tag.appendChild(ann_tag)
+                # Add interface annotation tags
+                for annotation, value in dict(
+                    itertools.chain.from_iterable(
+                        annotations().items()
+                        for name, annotations
+                        in self._get_all_dbus_things("interface")
+                        if name == if_tag.getAttribute("name")
+                        )).items():
+                    ann_tag = document.createElement("annotation")
+                    ann_tag.setAttribute("name", annotation)
+                    ann_tag.setAttribute("value", value)
+                    if_tag.appendChild(ann_tag)
+                # Fix argument name for the Introspect method itself
+                if (if_tag.getAttribute("name")
+                                == dbus.INTROSPECTABLE_IFACE):
+                    for cn in if_tag.getElementsByTagName("method"):
+                        if cn.getAttribute("name") == "Introspect":
+                            for arg in cn.getElementsByTagName("arg"):
+                                if (arg.getAttribute("direction")
+                                    == "out"):
+                                    arg.setAttribute("name",
+                                                     "xml_data")
+            xmlstring = document.toxml("utf-8")
+            document.unlink()
+        except (AttributeError, xml.dom.DOMException,
+                xml.parsers.expat.ExpatError) as error:
+            logger.error("Failed to override Introspection method",
+                         exc_info=error)
+        return xmlstring
+
+
+class DBusObjectWithProperties(DBusObjectWithAnnotations):
+    """A D-Bus object with properties.
+    
+    Classes inheriting from this can use the dbus_service_property
+    decorator to expose methods as D-Bus properties.  It exposes the
+    standard Get(), Set(), and GetAll() methods on the D-Bus.
+    """
+    
     def _get_dbus_property(self, interface_name, property_name):
         """Returns a bound method if one exists which is a D-Bus
         property with the specified name and interface.
@@ -898,6 +1243,15 @@
         raise DBusPropertyNotFound("{}:{}.{}".format(
             self.dbus_object_path, interface_name, property_name))
     
+    @classmethod
+    def _get_all_interface_names(cls):
+        """Get a sequence of all interfaces supported by an object"""
+        return (name for name in set(getattr(getattr(x, attr),
+                                             "_dbus_interface", None)
+                                     for x in (inspect.getmro(cls))
+                                     for attr in dir(x))
+                if name is not None)
+    
     @dbus.service.method(dbus.PROPERTIES_IFACE,
                          in_signature="ss",
                          out_signature="v")
@@ -973,8 +1327,9 @@
         
         Inserts property tags and interface annotation tags.
         """
-        xmlstring = dbus.service.Object.Introspect(self, object_path,
-                                                   connection)
+        xmlstring = DBusObjectWithAnnotations.Introspect(self,
+                                                         object_path,
+                                                         connection)
         try:
             document = xml.dom.minidom.parseString(xmlstring)
             
@@ -993,35 +1348,22 @@
                             if prop._dbus_interface
                             == if_tag.getAttribute("name")):
                     if_tag.appendChild(tag)
-                # Add annotation tags
-                for typ in ("method", "signal", "property"):
-                    for tag in if_tag.getElementsByTagName(typ):
-                        annots = dict()
-                        for name, prop in (self.
-                                           _get_all_dbus_things(typ)):
-                            if (name == tag.getAttribute("name")
-                                and prop._dbus_interface
-                                == if_tag.getAttribute("name")):
-                                annots.update(getattr(
-                                    prop, "_dbus_annotations", {}))
-                        for name, value in annots.items():
-                            ann_tag = document.createElement(
-                                "annotation")
-                            ann_tag.setAttribute("name", name)
-                            ann_tag.setAttribute("value", value)
-                            tag.appendChild(ann_tag)
-                # Add interface annotation tags
-                for annotation, value in dict(
-                    itertools.chain.from_iterable(
-                        annotations().items()
-                        for name, annotations
-                        in self._get_all_dbus_things("interface")
-                        if name == if_tag.getAttribute("name")
-                        )).items():
-                    ann_tag = document.createElement("annotation")
-                    ann_tag.setAttribute("name", annotation)
-                    ann_tag.setAttribute("value", value)
-                    if_tag.appendChild(ann_tag)
+                # Add annotation tags for properties
+                for tag in if_tag.getElementsByTagName("property"):
+                    annots = dict()
+                    for name, prop in self._get_all_dbus_things(
+                            "property"):
+                        if (name == tag.getAttribute("name")
+                            and prop._dbus_interface
+                            == if_tag.getAttribute("name")):
+                            annots.update(getattr(
+                                prop, "_dbus_annotations", {}))
+                    for name, value in annots.items():
+                        ann_tag = document.createElement(
+                            "annotation")
+                        ann_tag.setAttribute("name", name)
+                        ann_tag.setAttribute("value", value)
+                        tag.appendChild(ann_tag)
                 # Add the names to the return values for the
                 # "org.freedesktop.DBus.Properties" methods
                 if (if_tag.getAttribute("name")
@@ -1045,6 +1387,74 @@
                          exc_info=error)
         return xmlstring
 
+try:
+    dbus.OBJECT_MANAGER_IFACE
+except AttributeError:
+    dbus.OBJECT_MANAGER_IFACE = "org.freedesktop.DBus.ObjectManager"
+
+class DBusObjectWithObjectManager(DBusObjectWithAnnotations):
+    """A D-Bus object with an ObjectManager.
+    
+    Classes inheriting from this exposes the standard
+    GetManagedObjects call and the InterfacesAdded and
+    InterfacesRemoved signals on the standard
+    "org.freedesktop.DBus.ObjectManager" interface.
+    
+    Note: No signals are sent automatically; they must be sent
+    manually.
+    """
+    @dbus.service.method(dbus.OBJECT_MANAGER_IFACE,
+                         out_signature = "a{oa{sa{sv}}}")
+    def GetManagedObjects(self):
+        """This function must be overridden"""
+        raise NotImplementedError()
+    
+    @dbus.service.signal(dbus.OBJECT_MANAGER_IFACE,
+                         signature = "oa{sa{sv}}")
+    def InterfacesAdded(self, object_path, interfaces_and_properties):
+        pass
+    
+    @dbus.service.signal(dbus.OBJECT_MANAGER_IFACE, signature = "oas")
+    def InterfacesRemoved(self, object_path, interfaces):
+        pass
+    
+    @dbus.service.method(dbus.INTROSPECTABLE_IFACE,
+                         out_signature = "s",
+                         path_keyword = 'object_path',
+                         connection_keyword = 'connection')
+    def Introspect(self, object_path, connection):
+        """Overloading of standard D-Bus method.
+        
+        Override return argument name of GetManagedObjects to be
+        "objpath_interfaces_and_properties"
+        """
+        xmlstring = DBusObjectWithAnnotations.Introspect(self,
+                                                         object_path,
+                                                         connection)
+        try:
+            document = xml.dom.minidom.parseString(xmlstring)
+            
+            for if_tag in document.getElementsByTagName("interface"):
+                # Fix argument name for the GetManagedObjects method
+                if (if_tag.getAttribute("name")
+                                == dbus.OBJECT_MANAGER_IFACE):
+                    for cn in if_tag.getElementsByTagName("method"):
+                        if (cn.getAttribute("name")
+                            == "GetManagedObjects"):
+                            for arg in cn.getElementsByTagName("arg"):
+                                if (arg.getAttribute("direction")
+                                    == "out"):
+                                    arg.setAttribute(
+                                        "name",
+                                        "objpath_interfaces"
+                                        "_and_properties")
+            xmlstring = document.toxml("utf-8")
+            document.unlink()
+        except (AttributeError, xml.dom.DOMException,
+                xml.parsers.expat.ExpatError) as error:
+            logger.error("Failed to override Introspection method",
+                         exc_info = error)
+        return xmlstring
 
 def datetime_to_dbus(dt, variant_level=0):
     """Convert a UTC datetime.datetime() to a D-Bus type."""
@@ -1097,23 +1507,35 @@
                 interface_names.add(alt_interface)
                 # Is this a D-Bus signal?
                 if getattr(attribute, "_dbus_is_signal", False):
-                    # Extract the original non-method undecorated
-                    # function by black magic
-                    nonmethod_func = (dict(
-                        zip(attribute.func_code.co_freevars,
-                            attribute.__closure__))
-                                      ["func"].cell_contents)
+                    if sys.version_info.major == 2:
+                        # Extract the original non-method undecorated
+                        # function by black magic
+                        nonmethod_func = (dict(
+                            zip(attribute.func_code.co_freevars,
+                                attribute.__closure__))
+                                          ["func"].cell_contents)
+                    else:
+                        nonmethod_func = attribute
                     # Create a new, but exactly alike, function
                     # object, and decorate it to be a new D-Bus signal
                     # with the alternate D-Bus interface name
+                    if sys.version_info.major == 2:
+                        new_function = types.FunctionType(
+                            nonmethod_func.func_code,
+                            nonmethod_func.func_globals,
+                            nonmethod_func.func_name,
+                            nonmethod_func.func_defaults,
+                            nonmethod_func.func_closure)
+                    else:
+                        new_function = types.FunctionType(
+                            nonmethod_func.__code__,
+                            nonmethod_func.__globals__,
+                            nonmethod_func.__name__,
+                            nonmethod_func.__defaults__,
+                            nonmethod_func.__closure__)
                     new_function = (dbus.service.signal(
-                        alt_interface, attribute._dbus_signature)
-                                    (types.FunctionType(
-                                        nonmethod_func.func_code,
-                                        nonmethod_func.func_globals,
-                                        nonmethod_func.func_name,
-                                        nonmethod_func.func_defaults,
-                                        nonmethod_func.func_closure)))
+                        alt_interface,
+                        attribute._dbus_signature)(new_function))
                     # Copy annotations, if any
                     try:
                         new_function._dbus_annotations = dict(
@@ -1129,11 +1551,16 @@
                         func1 and func2 to the "call_both" function
                         outside of its arguments"""
                         
+                        @functools.wraps(func2)
                         def call_both(*args, **kwargs):
                             """This function will emit two D-Bus
                             signals by calling func1 and func2"""
                             func1(*args, **kwargs)
                             func2(*args, **kwargs)
+                        # Make wrapper function look like a D-Bus signal
+                        for name, attr in inspect.getmembers(func2):
+                            if name.startswith("_dbus_"):
+                                setattr(call_both, name, attr)
                         
                         return call_both
                     # Create the "call_both" function and add it to
@@ -1343,21 +1770,24 @@
         Client.__del__(self, *args, **kwargs)
     
     def checker_callback(self, source, condition,
-                         (connection, command), *args, **kwargs):
+                         connection, command, *args, **kwargs):
         ret = Client.checker_callback(self, source, condition,
-                                      (connection, command), *args,
+                                      connection, command, *args,
                                       **kwargs)
         exitstatus = self.last_checker_status
         if exitstatus >= 0:
             # Emit D-Bus signal
             self.CheckerCompleted(dbus.Int16(exitstatus),
-                                  dbus.Int64(0),
+                                  # This is specific to GNU libC
+                                  dbus.Int64(exitstatus << 8),
                                   dbus.String(command))
         else:
             # Emit D-Bus signal
             self.CheckerCompleted(dbus.Int16(-1),
                                   dbus.Int64(
-                                      self.last_checker_signal),
+                                      # This is specific to GNU libC
+                                      (exitstatus << 8)
+                                      | self.last_checker_signal),
                                   dbus.String(command))
         return ret
     
@@ -1440,24 +1870,28 @@
         self.checked_ok()
     
     # Enable - method
+    @dbus_annotations({"org.freedesktop.DBus.Deprecated": "true"})
     @dbus.service.method(_interface)
     def Enable(self):
         "D-Bus method"
         self.enable()
     
     # StartChecker - method
+    @dbus_annotations({"org.freedesktop.DBus.Deprecated": "true"})
     @dbus.service.method(_interface)
     def StartChecker(self):
         "D-Bus method"
         self.start_checker()
     
     # Disable - method
+    @dbus_annotations({"org.freedesktop.DBus.Deprecated": "true"})
     @dbus.service.method(_interface)
     def Disable(self):
         "D-Bus method"
         self.disable()
     
     # StopChecker - method
+    @dbus_annotations({"org.freedesktop.DBus.Deprecated": "true"})
     @dbus.service.method(_interface)
     def StopChecker(self):
         self.stop_checker()
@@ -1499,11 +1933,15 @@
         self.approval_duration = datetime.timedelta(0, 0, 0, value)
     
     # Name - property
+    @dbus_annotations(
+        {"org.freedesktop.DBus.Property.EmitsChangedSignal": "const"})
     @dbus_service_property(_interface, signature="s", access="read")
     def Name_dbus_property(self):
         return dbus.String(self.name)
     
     # Fingerprint - property
+    @dbus_annotations(
+        {"org.freedesktop.DBus.Property.EmitsChangedSignal": "const"})
     @dbus_service_property(_interface, signature="s", access="read")
     def Fingerprint_dbus_property(self):
         return dbus.String(self.fingerprint)
@@ -1518,6 +1956,8 @@
         self.host = str(value)
     
     # Created - property
+    @dbus_annotations(
+        {"org.freedesktop.DBus.Property.EmitsChangedSignal": "const"})
     @dbus_service_property(_interface, signature="s", access="read")
     def Created_dbus_property(self):
         return datetime_to_dbus(self.created)
@@ -1638,11 +2078,17 @@
             self.stop_checker()
     
     # ObjectPath - property
+    @dbus_annotations(
+        {"org.freedesktop.DBus.Property.EmitsChangedSignal": "const",
+         "org.freedesktop.DBus.Deprecated": "true"})
     @dbus_service_property(_interface, signature="o", access="read")
     def ObjectPath_dbus_property(self):
         return self.dbus_object_path # is already a dbus.ObjectPath
     
     # Secret = property
+    @dbus_annotations(
+        {"org.freedesktop.DBus.Property.EmitsChangedSignal":
+         "invalidates"})
     @dbus_service_property(_interface,
                            signature="ay",
                            access="write",
@@ -1658,7 +2104,7 @@
         self._pipe = child_pipe
         self._pipe.send(('init', fpr, address))
         if not self._pipe.recv():
-            raise KeyError()
+            raise KeyError(fpr)
     
     def __getattribute__(self, name):
         if name == '_pipe':
@@ -1694,13 +2140,7 @@
             logger.debug("Pipe FD: %d",
                          self.server.child_pipe.fileno())
             
-            session = gnutls.connection.ClientSession(
-                self.request, gnutls.connection .X509Credentials())
-            
-            # Note: gnutls.connection.X509Credentials is really a
-            # generic GnuTLS certificate credentials object so long as
-            # no X.509 keys are added to it.  Therefore, we can use it
-            # here despite using OpenPGP certificates.
+            session = gnutls.ClientSession(self.request)
             
             #priority = ':'.join(("NONE", "+VERS-TLS1.1",
             #                      "+AES-256-CBC", "+SHA1",
@@ -1710,8 +2150,8 @@
             priority = self.server.gnutls_priority
             if priority is None:
                 priority = "NORMAL"
-            gnutls.library.functions.gnutls_priority_set_direct(
-                session._c_object, priority, None)
+            gnutls.priority_set_direct(session._c_object, priority,
+                                       None)
             
             # Start communication using the Mandos protocol
             # Get protocol number
@@ -1727,7 +2167,7 @@
             # Start GnuTLS connection
             try:
                 session.handshake()
-            except gnutls.errors.GNUTLSError as error:
+            except gnutls.Error as error:
                 logger.warning("Handshake failed: %s", error)
                 # Do not run session.bye() here: the session is not
                 # established.  Just abandon the request.
@@ -1739,8 +2179,7 @@
                 try:
                     fpr = self.fingerprint(
                         self.peer_certificate(session))
-                except (TypeError,
-                        gnutls.errors.GNUTLSError) as error:
+                except (TypeError, gnutls.Error) as error:
                     logger.warning("Bad certificate: %s", error)
                     return
                 logger.debug("Fingerprint: %s", fpr)
@@ -1804,18 +2243,12 @@
                     else:
                         delay -= time2 - time
                 
-                sent_size = 0
-                while sent_size < len(client.secret):
-                    try:
-                        sent = session.send(client.secret[sent_size:])
-                    except gnutls.errors.GNUTLSError as error:
-                        logger.warning("gnutls send failed",
-                                       exc_info=error)
-                        return
-                    logger.debug("Sent: %d, remaining: %d", sent,
-                                 len(client.secret) - (sent_size
-                                                       + sent))
-                    sent_size += sent
+                try:
+                    session.send(client.secret)
+                except gnutls.Error as error:
+                    logger.warning("gnutls send failed",
+                                   exc_info = error)
+                    return
                 
                 logger.info("Sending secret to %s", client.name)
                 # bump the timeout using extended_timeout
@@ -1829,7 +2262,7 @@
                     client.approvals_pending -= 1
                 try:
                     session.bye()
-                except gnutls.errors.GNUTLSError as error:
+                except gnutls.Error as error:
                     logger.warning("GnuTLS bye failed",
                                    exc_info=error)
     
@@ -1837,18 +2270,15 @@
     def peer_certificate(session):
         "Return the peer's OpenPGP certificate as a bytestring"
         # If not an OpenPGP certificate...
-        if (gnutls.library.functions.gnutls_certificate_type_get(
-                session._c_object)
-            != gnutls.library.constants.GNUTLS_CRT_OPENPGP):
-            # ...do the normal thing
-            return session.peer_certificate
+        if (gnutls.certificate_type_get(session._c_object)
+            != gnutls.CRT_OPENPGP):
+            # ...return invalid data
+            return b""
         list_size = ctypes.c_uint(1)
-        cert_list = (gnutls.library.functions
-                     .gnutls_certificate_get_peers
+        cert_list = (gnutls.certificate_get_peers
                      (session._c_object, ctypes.byref(list_size)))
         if not bool(cert_list) and list_size.value != 0:
-            raise gnutls.errors.GNUTLSError("error getting peer"
-                                            " certificate")
+            raise gnutls.Error("error getting peer certificate")
         if list_size.value == 0:
             return None
         cert = cert_list[0]
@@ -1858,34 +2288,31 @@
     def fingerprint(openpgp):
         "Convert an OpenPGP bytestring to a hexdigit fingerprint"
         # New GnuTLS "datum" with the OpenPGP public key
-        datum = gnutls.library.types.gnutls_datum_t(
+        datum = gnutls.datum_t(
             ctypes.cast(ctypes.c_char_p(openpgp),
                         ctypes.POINTER(ctypes.c_ubyte)),
             ctypes.c_uint(len(openpgp)))
         # New empty GnuTLS certificate
-        crt = gnutls.library.types.gnutls_openpgp_crt_t()
-        gnutls.library.functions.gnutls_openpgp_crt_init(
-            ctypes.byref(crt))
+        crt = gnutls.openpgp_crt_t()
+        gnutls.openpgp_crt_init(ctypes.byref(crt))
         # Import the OpenPGP public key into the certificate
-        gnutls.library.functions.gnutls_openpgp_crt_import(
-            crt, ctypes.byref(datum),
-            gnutls.library.constants.GNUTLS_OPENPGP_FMT_RAW)
+        gnutls.openpgp_crt_import(crt, ctypes.byref(datum),
+                                  gnutls.OPENPGP_FMT_RAW)
         # Verify the self signature in the key
         crtverify = ctypes.c_uint()
-        gnutls.library.functions.gnutls_openpgp_crt_verify_self(
-            crt, 0, ctypes.byref(crtverify))
+        gnutls.openpgp_crt_verify_self(crt, 0,
+                                       ctypes.byref(crtverify))
         if crtverify.value != 0:
-            gnutls.library.functions.gnutls_openpgp_crt_deinit(crt)
-            raise gnutls.errors.CertificateSecurityError(
-                "Verify failed")
+            gnutls.openpgp_crt_deinit(crt)
+            raise gnutls.CertificateSecurityError("Verify failed")
         # New buffer for the fingerprint
         buf = ctypes.create_string_buffer(20)
         buf_len = ctypes.c_size_t()
         # Get the fingerprint from the certificate into the buffer
-        gnutls.library.functions.gnutls_openpgp_crt_get_fingerprint(
-            crt, ctypes.byref(buf), ctypes.byref(buf_len))
+        gnutls.openpgp_crt_get_fingerprint(crt, ctypes.byref(buf),
+                                           ctypes.byref(buf_len))
         # Deinit the certificate
-        gnutls.library.functions.gnutls_openpgp_crt_deinit(crt)
+        gnutls.openpgp_crt_deinit(crt)
         # Convert the buffer to a Python bytestring
         fpr = ctypes.string_at(buf, buf_len.value)
         # Convert the bytestring to hexadecimal notation
@@ -2127,7 +2554,8 @@
         
         if command == 'getattr':
             attrname = request[1]
-            if callable(client_object.__getattribute__(attrname)):
+            if isinstance(client_object.__getattribute__(attrname),
+                          collections.Callable):
                 parent_pipe.send(('function', ))
             else:
                 parent_pipe.send((
@@ -2168,15 +2596,6 @@
     # avoid excessive use of external libraries.
     
     # New type for defining tokens, syntax, and semantics all-in-one
-    Token = collections.namedtuple("Token",
-                                   ("regexp", # To match token; if
-                                              # "value" is not None,
-                                              # must have a "group"
-                                              # containing digits
-                                    "value",  # datetime.timedelta or
-                                              # None
-                                    "followers")) # Tokens valid after
-                                                  # this token
     Token = collections.namedtuple("Token", (
         "regexp",  # To match token; if "value" is not None, must have
                    # a "group" containing digits
@@ -2217,7 +2636,7 @@
     # Define starting values
     value = datetime.timedelta() # Value so far
     found_token = None
-    followers = frozenset((token_duration,)) # Following valid tokens
+    followers = frozenset((token_duration, )) # Following valid tokens
     s = duration                # String left to parse
     # Loop until end token is found
     while found_token is not token_end:
@@ -2240,7 +2659,8 @@
                 break
         else:
             # No currently valid tokens were found
-            raise ValueError("Invalid RFC 3339 duration")
+            raise ValueError("Invalid RFC 3339 duration: {!r}"
+                             .format(duration))
     # End token found
     return value
 
@@ -2379,7 +2799,7 @@
                         "debug": "False",
                         "priority":
                         "SECURE256:!CTYPE-X.509:+CTYPE-OPENPGP:!RSA"
-                        ":+SIGN-RSA-SHA224:+SIGN-RSA-RMD160",
+                        ":+SIGN-DSA-SHA256",
                         "servicename": "Mandos",
                         "use_dbus": "True",
                         "use_ipv6": "True",
@@ -2497,7 +2917,7 @@
             pidfilename = "/var/run/mandos.pid"
         pidfile = None
         try:
-            pidfile = open(pidfilename, "w")
+            pidfile = codecs.open(pidfilename, "w", encoding="utf-8")
         except IOError as e:
             logger.error("Could not open file %r", pidfilename,
                          exc_info=e)
@@ -2524,14 +2944,13 @@
         
         # "Use a log level over 10 to enable all debugging options."
         # - GnuTLS manual
-        gnutls.library.functions.gnutls_global_set_log_level(11)
+        gnutls.global_set_log_level(11)
         
-        @gnutls.library.types.gnutls_log_func
+        @gnutls.log_func
         def debug_gnutls(level, string):
             logger.debug("GnuTLS: %s", string[:-1])
         
-        gnutls.library.functions.gnutls_global_set_log_function(
-            debug_gnutls)
+        gnutls.global_set_log_function(debug_gnutls)
         
         # Redirect stdin so all checkers get /dev/null
         null = os.open(os.devnull, os.O_NOCTTY | os.O_RDWR)
@@ -2562,7 +2981,7 @@
             old_bus_name = dbus.service.BusName(
                 "se.bsnet.fukt.Mandos", bus,
                 do_not_queue=True)
-        except dbus.exceptions.NameExistsException as e:
+        except dbus.exceptions.DBusException as e:
             logger.error("Disabling D-Bus:", exc_info=e)
             use_dbus = False
             server_settings["use_dbus"] = False
@@ -2699,10 +3118,10 @@
     
     if not foreground:
         if pidfile is not None:
+            pid = os.getpid()
             try:
                 with pidfile:
-                    pid = os.getpid()
-                    pidfile.write("{}\n".format(pid).encode("utf-8"))
+                    print(pid, file=pidfile)
             except IOError:
                 logger.error("Could not write to file %r with PID %d",
                              pidfilename, pid)
@@ -2716,7 +3135,7 @@
         
         @alternate_dbus_interfaces(
             { "se.recompile.Mandos": "se.bsnet.fukt.Mandos" })
-        class MandosDBusService(DBusObjectWithProperties):
+        class MandosDBusService(DBusObjectWithObjectManager):
             """A D-Bus proxy object"""
             
             def __init__(self):
@@ -2724,12 +3143,6 @@
             
             _interface = "se.recompile.Mandos"
             
-            @dbus_interface_annotations(_interface)
-            def _foo(self):
-                return {
-                    "org.freedesktop.DBus.Property.EmitsChangedSignal":
-                    "false" }
-            
             @dbus.service.signal(_interface, signature="o")
             def ClientAdded(self, objpath):
                 "D-Bus signal"
@@ -2740,23 +3153,30 @@
                 "D-Bus signal"
                 pass
             
+            @dbus_annotations({"org.freedesktop.DBus.Deprecated":
+                               "true"})
             @dbus.service.signal(_interface, signature="os")
             def ClientRemoved(self, objpath, name):
                 "D-Bus signal"
                 pass
             
+            @dbus_annotations({"org.freedesktop.DBus.Deprecated":
+                               "true"})
             @dbus.service.method(_interface, out_signature="ao")
             def GetAllClients(self):
                 "D-Bus method"
                 return dbus.Array(c.dbus_object_path for c in
                                   tcp_server.clients.itervalues())
             
+            @dbus_annotations({"org.freedesktop.DBus.Deprecated":
+                               "true"})
             @dbus.service.method(_interface,
                                  out_signature="a{oa{sv}}")
             def GetAllClientsWithProperties(self):
                 "D-Bus method"
                 return dbus.Dictionary(
-                    { c.dbus_object_path: c.GetAll("")
+                    { c.dbus_object_path: c.GetAll(
+                        "se.recompile.Mandos.Client")
                       for c in tcp_server.clients.itervalues() },
                     signature="oa{sv}")
             
@@ -2767,14 +3187,50 @@
                     if c.dbus_object_path == object_path:
                         del tcp_server.clients[c.name]
                         c.remove_from_connection()
-                        # Don't signal anything except ClientRemoved
+                        # Don't signal the disabling
                         c.disable(quiet=True)
-                        # Emit D-Bus signal
-                        self.ClientRemoved(object_path, c.name)
+                        # Emit D-Bus signal for removal
+                        self.client_removed_signal(c)
                         return
                 raise KeyError(object_path)
             
             del _interface
+            
+            @dbus.service.method(dbus.OBJECT_MANAGER_IFACE,
+                                 out_signature = "a{oa{sa{sv}}}")
+            def GetManagedObjects(self):
+                """D-Bus method"""
+                return dbus.Dictionary(
+                    { client.dbus_object_path:
+                      dbus.Dictionary(
+                          { interface: client.GetAll(interface)
+                            for interface in
+                                 client._get_all_interface_names()})
+                      for client in tcp_server.clients.values()})
+            
+            def client_added_signal(self, client):
+                """Send the new standard signal and the old signal"""
+                if use_dbus:
+                    # New standard signal
+                    self.InterfacesAdded(
+                        client.dbus_object_path,
+                        dbus.Dictionary(
+                            { interface: client.GetAll(interface)
+                              for interface in
+                              client._get_all_interface_names()}))
+                    # Old signal
+                    self.ClientAdded(client.dbus_object_path)
+            
+            def client_removed_signal(self, client):
+                """Send the new standard signal and the old signal"""
+                if use_dbus:
+                    # New standard signal
+                    self.InterfacesRemoved(
+                        client.dbus_object_path,
+                        client._get_all_interface_names())
+                    # Old signal
+                    self.ClientRemoved(client.dbus_object_path,
+                                       client.name)
         
         mandos_dbus_service = MandosDBusService()
     
@@ -2845,20 +3301,19 @@
             name, client = tcp_server.clients.popitem()
             if use_dbus:
                 client.remove_from_connection()
-            # Don't signal anything except ClientRemoved
+            # Don't signal the disabling
             client.disable(quiet=True)
+            # Emit D-Bus signal for removal
             if use_dbus:
-                # Emit D-Bus signal
-                mandos_dbus_service.ClientRemoved(
-                    client.dbus_object_path, client.name)
+                mandos_dbus_service.client_removed_signal(client)
         client_settings.clear()
     
     atexit.register(cleanup)
     
     for client in tcp_server.clients.itervalues():
         if use_dbus:
-            # Emit D-Bus signal
-            mandos_dbus_service.ClientAdded(client.dbus_object_path)
+            # Emit D-Bus signal for adding
+            mandos_dbus_service.client_added_signal(client)
         # Need to initiate checking of clients
         if client.enabled:
             client.init_checker()

=== modified file 'mandos-clients.conf.xml'
--- mandos-clients.conf.xml	2014-06-22 02:19:30 +0000
+++ mandos-clients.conf.xml	2016-02-28 14:22:10 +0000
@@ -3,7 +3,7 @@
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY CONFNAME "mandos-clients.conf">
 <!ENTITY CONFPATH "<filename>/etc/mandos/clients.conf</filename>">
-<!ENTITY TIMESTAMP "2014-06-22">
+<!ENTITY TIMESTAMP "2016-02-28">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -37,6 +37,10 @@
       <year>2010</year>
       <year>2011</year>
       <year>2012</year>
+      <year>2013</year>
+      <year>2014</year>
+      <year>2015</year>
+      <year>2016</year>
       <holder>Teddy Hogeborn</holder>
       <holder>Björn Påhlsson</holder>
     </copyright>

=== modified file 'mandos-ctl'
--- mandos-ctl	2015-04-02 21:56:15 +0000
+++ mandos-ctl	2016-02-28 14:22:10 +0000
@@ -3,8 +3,8 @@
 # 
 # Mandos Monitor - Control and monitor the Mandos server
 # 
-# Copyright © 2008-2015 Teddy Hogeborn
-# Copyright © 2008-2015 Björn Påhlsson
+# Copyright © 2008-2016 Teddy Hogeborn
+# Copyright © 2008-2016 Björn Påhlsson
 # 
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -72,8 +72,13 @@
 server_path = "/"
 server_interface = domain + ".Mandos"
 client_interface = domain + ".Mandos.Client"
-version = "1.6.9"
-
+version = "1.7.1"
+
+
+try:
+    dbus.OBJECT_MANAGER_IFACE
+except AttributeError:
+    dbus.OBJECT_MANAGER_IFACE = "org.freedesktop.DBus.ObjectManager"
 
 def milliseconds_to_string(ms):
     td = datetime.timedelta(0, 0, 0, ms)
@@ -111,15 +116,11 @@
     # avoid excessive use of external libraries.
     
     # New type for defining tokens, syntax, and semantics all-in-one
-    Token = collections.namedtuple("Token",
-                                   ("regexp", # To match token; if
-                                              # "value" is not None,
-                                              # must have a "group"
-                                              # containing digits
-                                    "value",  # datetime.timedelta or
-                                              # None
-                                    "followers")) # Tokens valid after
-                                                  # this token
+    Token = collections.namedtuple("Token", (
+        "regexp",  # To match token; if "value" is not None, must have
+                   # a "group" containing digits
+        "value",   # datetime.timedelta or None
+        "followers"))           # Tokens valid after this token
     # RFC 3339 "duration" tokens, syntax, and semantics; taken from
     # the "duration" ABNF definition in RFC 3339, Appendix A.
     token_end = Token(re.compile(r"$"), None, frozenset())
@@ -178,7 +179,8 @@
                 break
         else:
             # No currently valid tokens were found
-            raise ValueError("Invalid RFC 3339 duration")
+            raise ValueError("Invalid RFC 3339 duration: {!r}"
+                             .format(duration))
     # End token found
     return value
 
@@ -186,17 +188,17 @@
 def string_to_delta(interval):
     """Parse a string and return a datetime.timedelta
     
-    >>> string_to_delta("7d")
+    >>> string_to_delta('7d')
     datetime.timedelta(7)
-    >>> string_to_delta("60s")
+    >>> string_to_delta('60s')
     datetime.timedelta(0, 60)
-    >>> string_to_delta("60m")
+    >>> string_to_delta('60m')
     datetime.timedelta(0, 3600)
-    >>> string_to_delta("24h")
+    >>> string_to_delta('24h')
     datetime.timedelta(1)
-    >>> string_to_delta("1w")
+    >>> string_to_delta('1w')
     datetime.timedelta(7)
-    >>> string_to_delta("5m 30s")
+    >>> string_to_delta('5m 30s')
     datetime.timedelta(0, 330)
     """
     
@@ -344,6 +346,8 @@
     
     mandos_serv = dbus.Interface(mandos_dbus_objc,
                                  dbus_interface = server_interface)
+    mandos_serv_object_manager = dbus.Interface(
+        mandos_dbus_objc, dbus_interface = dbus.OBJECT_MANAGER_IFACE)
     
     #block stderr since dbus library prints to stderr
     null = os.open(os.path.devnull, os.O_RDWR)
@@ -352,14 +356,18 @@
     os.close(null)
     try:
         try:
-            mandos_clients = mandos_serv.GetAllClientsWithProperties()
+            mandos_clients = { path: ifs_and_props[client_interface]
+                               for path, ifs_and_props in
+                               mandos_serv_object_manager
+                               .GetManagedObjects().items()
+                               if client_interface in ifs_and_props }
         finally:
             #restore stderr
             os.dup2(stderrcopy, sys.stderr.fileno())
             os.close(stderrcopy)
-    except dbus.exceptions.DBusException:
-        print("Access denied: Accessing mandos server through dbus.",
-              file=sys.stderr)
+    except dbus.exceptions.DBusException as e:
+        print("Access denied: Accessing mandos server through D-Bus: {}"
+              .format(e), file=sys.stderr)
         sys.exit(1)
     
     # Compile dict of (clients: properties) to process

=== modified file 'mandos-ctl.xml'
--- mandos-ctl.xml	2012-06-22 23:33:56 +0000
+++ mandos-ctl.xml	2016-02-28 14:22:10 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "mandos-ctl">
-<!ENTITY TIMESTAMP "2012-06-22">
+<!ENTITY TIMESTAMP "2016-02-28">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -34,6 +34,10 @@
       <year>2010</year>
       <year>2011</year>
       <year>2012</year>
+      <year>2013</year>
+      <year>2014</year>
+      <year>2015</year>
+      <year>2016</year>
       <holder>Teddy Hogeborn</holder>
       <holder>Björn Påhlsson</holder>
     </copyright>

=== modified file 'mandos-keygen'
--- mandos-keygen	2015-05-23 10:41:35 +0000
+++ mandos-keygen	2016-02-28 14:22:10 +0000
@@ -2,8 +2,8 @@
 # 
 # Mandos key generator - create a new OpenPGP key for a Mandos client
 # 
-# Copyright © 2008-2015 Teddy Hogeborn
-# Copyright © 2008-2015 Björn Påhlsson
+# Copyright © 2008-2016 Teddy Hogeborn
+# Copyright © 2008-2016 Björn Påhlsson
 # 
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -21,7 +21,7 @@
 # Contact the authors at <mandos@recompile.se>.
 # 
 
-VERSION="1.6.9"
+VERSION="1.7.1"
 
 KEYDIR="/etc/keys/mandos"
 KEYTYPE=RSA

=== modified file 'mandos-keygen.xml'
--- mandos-keygen.xml	2014-06-22 02:19:30 +0000
+++ mandos-keygen.xml	2016-02-28 14:22:10 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "mandos-keygen">
-<!ENTITY TIMESTAMP "2014-06-22">
+<!ENTITY TIMESTAMP "2016-02-28">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -33,8 +33,13 @@
     <copyright>
       <year>2008</year>
       <year>2009</year>
+      <year>2010</year>
       <year>2011</year>
       <year>2012</year>
+      <year>2013</year>
+      <year>2014</year>
+      <year>2015</year>
+      <year>2016</year>
       <holder>Teddy Hogeborn</holder>
       <holder>Björn Påhlsson</holder>
     </copyright>

=== modified file 'mandos-monitor'
--- mandos-monitor	2015-05-23 20:18:34 +0000
+++ mandos-monitor	2016-02-28 14:22:10 +0000
@@ -3,8 +3,8 @@
 # 
 # Mandos Monitor - Control and monitor the Mandos server
 # 
-# Copyright © 2009-2015 Teddy Hogeborn
-# Copyright © 2009-2015 Björn Påhlsson
+# Copyright © 2009-2016 Teddy Hogeborn
+# Copyright © 2009-2016 Björn Påhlsson
 # 
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -60,7 +60,12 @@
 domain = 'se.recompile'
 server_interface = domain + '.Mandos'
 client_interface = domain + '.Mandos.Client'
-version = "1.6.9"
+version = "1.7.1"
+
+try:
+    dbus.OBJECT_MANAGER_IFACE
+except AttributeError:
+    dbus.OBJECT_MANAGER_IFACE = "org.freedesktop.DBus.ObjectManager"
 
 def isoformat_to_datetime(iso):
     "Parse an ISO 8601 date string to a datetime.datetime()"
@@ -105,7 +110,8 @@
         It updates the changed properties in the "properties" dict.
         """
         # Update properties dict with new value
-        self.properties.update(properties)
+        if interface == client_interface:
+            self.properties.update(properties)
     
     def delete(self):
         self.property_changed_match.remove()
@@ -173,7 +179,7 @@
             gobject.source_remove(self._update_timer_callback_tag)
             self._update_timer_callback_tag = None
     
-    def checker_completed(self, exitstatus, signal, command):
+    def checker_completed(self, exitstatus, condition, command):
         if exitstatus == 0:
             self.logger('Checker for client {} (command "{}")'
                         ' succeeded'.format(self.properties["Name"],
@@ -181,20 +187,16 @@
             self.update()
             return
         # Checker failed
-        if exitstatus >= 0:
+        if os.WIFEXITED(condition):
             self.logger('Checker for client {} (command "{}") failed'
                         ' with exit code {}'
                         .format(self.properties["Name"], command,
-                                exitstatus))
-        elif signal != 0:
+                                os.WEXITSTATUS(condition)))
+        elif os.WIFSIGNALED(condition):
             self.logger('Checker for client {} (command "{}") was'
                         ' killed by signal {}'
                         .format(self.properties["Name"], command,
-                                signal))
-        else:
-            self.logger('Checker for client {} completed'
-                        ' mysteriously'
-                        .format(self.properties["Name"]))
+                                os.WTERMSIG(condition)))
         self.update()
     
     def checker_started(self, command):
@@ -333,11 +335,13 @@
         """Handle keys.
         This overrides the method from urwid.FlowWidget"""
         if key == "+":
-            self.proxy.Enable(dbus_interface = client_interface,
-                              ignore_reply=True)
+            self.proxy.Set(client_interface, "Enabled",
+                           dbus.Boolean(True), ignore_reply = True,
+                           dbus_interface = dbus.PROPERTIES_IFACE)
         elif key == "-":
-            self.proxy.Disable(dbus_interface = client_interface,
-                               ignore_reply=True)
+            self.proxy.Set(client_interface, "Enabled", False,
+                           ignore_reply = True,
+                           dbus_interface = dbus.PROPERTIES_IFACE)
         elif key == "a":
             self.proxy.Approve(dbus.Boolean(True, variant_level=1),
                                dbus_interface = client_interface,
@@ -351,11 +355,13 @@
                                                   .object_path,
                                                   ignore_reply=True)
         elif key == "s":
-            self.proxy.StartChecker(dbus_interface = client_interface,
-                                    ignore_reply=True)
+            self.proxy.Set(client_interface, "CheckerRunning",
+                           dbus.Boolean(True), ignore_reply = True,
+                           dbus_interface = dbus.PROPERTIES_IFACE)
         elif key == "S":
-            self.proxy.StopChecker(dbus_interface = client_interface,
-                                   ignore_reply=True)
+            self.proxy.Set(client_interface, "CheckerRunning",
+                           dbus.Boolean(False), ignore_reply = True,
+                           dbus_interface = dbus.PROPERTIES_IFACE)
         elif key == "C":
             self.proxy.CheckedOK(dbus_interface = client_interface,
                                  ignore_reply=True)
@@ -521,21 +527,32 @@
         self.log_message("Wrap mode: {}".format(self.log_wrap),
                          level=0)
     
-    def find_and_remove_client(self, path, name):
+    def find_and_remove_client(self, path, interfaces):
         """Find a client by its object path and remove it.
         
-        This is connected to the ClientRemoved signal from the
+        This is connected to the InterfacesRemoved signal from the
         Mandos server object."""
+        if client_interface not in interfaces:
+            # Not a Mandos client object; ignore
+            return
         try:
             client = self.clients_dict[path]
         except KeyError:
             # not found?
-            self.log_message("Unknown client {!r} ({!r}) removed"
-                             .format(name, path))
+            self.log_message("Unknown client {!r} removed"
+                             .format(path))
             return
         client.delete()
     
-    def add_new_client(self, path):
+    def add_new_client(self, path, ifs_and_props):
+        """Find a client by its object path and remove it.
+        
+        This is connected to the InterfacesAdded signal from the
+        Mandos server object.
+        """
+        if client_interface not in ifs_and_props:
+            # Not a Mandos client object; ignore
+            return
         client_proxy_object = self.bus.get_object(self.busname, path)
         self.add_client(MandosClientWidget(server_proxy_object
                                            =self.mandos_serv,
@@ -546,7 +563,10 @@
                                            delete_hook
                                            =self.remove_client,
                                            logger
-                                           =self.log_message),
+                                           =self.log_message,
+                                           properties
+                                           = dict(ifs_and_props[
+                                               client_interface])),
                         path=path)
     
     def add_client(self, client, path=None):
@@ -587,14 +607,16 @@
             mandos_clients = dbus.Dictionary()
         
         (self.mandos_serv
-         .connect_to_signal("ClientRemoved",
+         .connect_to_signal("InterfacesRemoved",
                             self.find_and_remove_client,
-                            dbus_interface=server_interface,
+                            dbus_interface
+                            = dbus.OBJECT_MANAGER_IFACE,
                             byte_arrays=True))
         (self.mandos_serv
-         .connect_to_signal("ClientAdded",
+         .connect_to_signal("InterfacesAdded",
                             self.add_new_client,
-                            dbus_interface=server_interface,
+                            dbus_interface
+                            = dbus.OBJECT_MANAGER_IFACE,
                             byte_arrays=True))
         (self.mandos_serv
          .connect_to_signal("ClientNotFound",

=== modified file 'mandos-monitor.xml'
--- mandos-monitor.xml	2014-07-14 21:41:08 +0000
+++ mandos-monitor.xml	2016-02-28 14:22:10 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "mandos-monitor">
-<!ENTITY TIMESTAMP "2014-07-14">
+<!ENTITY TIMESTAMP "2016-02-28">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -34,6 +34,10 @@
       <year>2010</year>
       <year>2011</year>
       <year>2012</year>
+      <year>2013</year>
+      <year>2014</year>
+      <year>2015</year>
+      <year>2016</year>
       <holder>Teddy Hogeborn</holder>
       <holder>Björn Påhlsson</holder>
     </copyright>

=== modified file 'mandos-options.xml'
--- mandos-options.xml	2015-03-10 18:03:38 +0000
+++ mandos-options.xml	2015-07-20 03:03:33 +0000
@@ -46,24 +46,11 @@
     <emphasis>not</emphasis> run in debug mode.
   </para>
   
-  <para id="priority_compat">
+  <para id="priority">
     GnuTLS priority string for the <acronym>TLS</acronym> handshake.
     The default is <quote><literal
     >SECURE256:!CTYPE-X.509:+CTYPE-OPENPGP:!RSA</literal>
-    <literal>:+SIGN-RSA-SHA224:+SIGN-RSA-RMD160</literal></quote>.
-    See <citerefentry><refentrytitle
-    >gnutls_priority_init</refentrytitle>
-    <manvolnum>3</manvolnum></citerefentry> for the syntax.
-    <emphasis>Warning</emphasis>: changing this may make the
-    <acronym>TLS</acronym> handshake fail, making server-client
-    communication impossible.  Changing this option may also make the
-    network traffic decryptable by an attacker.
-  </para>
-  
-  <para id="priority">
-    GnuTLS priority string for the <acronym>TLS</acronym> handshake.
-    The default is <quote><literal
-    >SECURE256:!CTYPE-X.509:+CTYPE-OPENPGP:!RSA</literal></quote>.
+    <literal>:+SIGN-DSA-SHA256</literal></quote>.
     See <citerefentry><refentrytitle
     >gnutls_priority_init</refentrytitle>
     <manvolnum>3</manvolnum></citerefentry> for the syntax.

=== modified file 'mandos.conf'
--- mandos.conf	2015-04-02 18:59:29 +0000
+++ mandos.conf	2015-07-20 03:03:33 +0000
@@ -23,7 +23,7 @@
 ;debug = False
 
 # GnuTLS priority for the TLS handshake.  See gnutls_priority_init(3).
-;priority = SECURE256:!CTYPE-X.509:+CTYPE-OPENPGP:!RSA:+SIGN-RSA-SHA224:+SIGN-RSA-RMD160
+;priority = SECURE256:!CTYPE-X.509:+CTYPE-OPENPGP:!RSA:+SIGN-DSA-SHA256
 
 # Zeroconf service name.  You need to change this if you for some
 # reason want to run more than one server on the same *host*.

=== modified file 'mandos.conf.xml'
--- mandos.conf.xml	2015-04-02 18:59:29 +0000
+++ mandos.conf.xml	2016-02-28 14:22:10 +0000
@@ -3,7 +3,7 @@
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY CONFNAME "mandos.conf">
 <!ENTITY CONFPATH "<filename>/etc/mandos/mandos.conf</filename>">
-<!ENTITY TIMESTAMP "2015-04-02">
+<!ENTITY TIMESTAMP "2016-02-28">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -34,9 +34,13 @@
     <copyright>
       <year>2008</year>
       <year>2009</year>
+      <year>2010</year>
       <year>2011</year>
       <year>2012</year>
       <year>2013</year>
+      <year>2014</year>
+      <year>2015</year>
+      <year>2016</year>
       <holder>Teddy Hogeborn</holder>
       <holder>Björn Påhlsson</holder>
     </copyright>
@@ -121,8 +125,7 @@
 	<term><option>priority<literal> = </literal><replaceable
 	>STRING</replaceable></option></term>
 	<listitem>
-	  <xi:include href="mandos-options.xml"
-                      xpointer="priority_compat"/>
+	  <xi:include href="mandos-options.xml" xpointer="priority"/>
 	</listitem>
       </varlistentry>
       

=== modified file 'mandos.lsm'
--- mandos.lsm	2014-10-05 20:08:58 +0000
+++ mandos.lsm	2015-10-24 17:48:13 +0000
@@ -1,7 +1,7 @@
 Begin4
 Title:		Mandos
-Version:	1.6.9
-Entered-date:	2014-10-05
+Version:	1.7.1
+Entered-date:	2015-10-24
 Description:	The Mandos system allows computers to have encrypted
 		root file systems and at the same time be capable of
 		remote and/or unattended reboots.
@@ -12,10 +12,10 @@
 Maintained-by:	teddy@recompile.se (Teddy Hogeborn),
 		belorn@recompile.se (Björn Påhlsson)
 Primary-site:	http://www.recompile.se/mandos
-		161K mandos_1.6.9.orig.tar.gz
+		169K mandos_1.7.1.orig.tar.gz
 Alternate-site:	ftp://ftp.recompile.se/pub/mandos
-		161K mandos_1.6.9.orig.tar.gz
-Platforms:	Requires GCC, GNU libC, Avahi, GnuPG, Python 2.6, and
+		169K mandos_1.7.1.orig.tar.gz
+Platforms:	Requires GCC, GNU libC, Avahi, GnuPG, Python 2.7, and
 		various other libraries.  While made for Debian
 		GNU/Linux, it is probably portable to other
 		distributions, but not other Unixes.

=== modified file 'mandos.service'
--- mandos.service	2014-10-05 19:39:25 +0000
+++ mandos.service	2015-08-10 16:19:28 +0000
@@ -1,20 +1,24 @@
 [Unit]
 Description=Server of encrypted passwords to Mandos clients
 Documentation=man:intro(8mandos) man:mandos(8)
+## If the server is configured to listen to a specific IP or network
+## interface, it may be necessary to change "network.target" to
+## "network-online.target".
+After=network.target
+## If the server is configured to not use ZeroConf, these two lines
+## become unnecessary and should be removed or commented out.
+After=avahi-daemon.service
+RequisiteOverridable=avahi-daemon.service
 
 [Service]
-Type=simple
-## Type=dbus is not appropriate, because Mandos also needs to announce
-## its ZeroConf service and be reachable on the network.
-#Type=dbus
-#BusName=se.recompile.Mandos
-# If you add --no-dbus, also comment out BusName above, and vice versa
+## If the server's D-Bus interface is disabled, the "BusName" setting
+## should be removed or commented out.
+BusName=se.recompile.Mandos
 ExecStart=/usr/sbin/mandos --foreground
 Restart=always
-KillMode=process
-## Using socket activation won't work either, because systemd always
-## does bind() on the socket, and also won't announce the ZeroConf
-## service.
+KillMode=mixed
+## Using socket activation won't work, because systemd always does
+## bind() on the socket, and also won't announce the ZeroConf service.
 #ExecStart=/usr/sbin/mandos --foreground --socket=0
 #StandardInput=socket
 

=== modified file 'mandos.xml'
--- mandos.xml	2015-01-25 00:02:51 +0000
+++ mandos.xml	2016-02-28 14:22:10 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 "http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "mandos">
-<!ENTITY TIMESTAMP "2015-01-25">
+<!ENTITY TIMESTAMP "2016-02-28">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -37,6 +37,9 @@
       <year>2011</year>
       <year>2012</year>
       <year>2013</year>
+      <year>2014</year>
+      <year>2015</year>
+      <year>2016</year>
       <holder>Teddy Hogeborn</holder>
       <holder>Björn Påhlsson</holder>
     </copyright>
@@ -236,8 +239,7 @@
 	<term><option>--priority <replaceable>
 	PRIORITY</replaceable></option></term>
 	<listitem>
-	  <xi:include href="mandos-options.xml"
-                      xpointer="priority_compat"/>
+	  <xi:include href="mandos-options.xml" xpointer="priority"/>
 	</listitem>
       </varlistentry>
       
@@ -540,9 +542,6 @@
 	</listitem>
       </varlistentry>
       <varlistentry>
-	<term><filename class="devicefile">/dev/log</filename></term>
-      </varlistentry>
-      <varlistentry>
 	<term><filename
 	class="directory">/var/lib/mandos</filename></term>
 	<listitem>
@@ -554,7 +553,7 @@
 	</listitem>
       </varlistentry>
       <varlistentry>
-	<term><filename>/dev/log</filename></term>
+	<term><filename class="devicefile">/dev/log</filename></term>
 	<listitem>
 	  <para>
 	    The Unix domain socket to where local syslog messages are

=== added directory 'plugin-helpers'
=== added file 'plugin-helpers/mandos-client-iprouteadddel.c'
--- plugin-helpers/mandos-client-iprouteadddel.c	1970-01-01 00:00:00 +0000
+++ plugin-helpers/mandos-client-iprouteadddel.c	2016-02-28 14:22:10 +0000
@@ -0,0 +1,282 @@
+/*  -*- coding: utf-8 -*- */
+/* 
+ * iprouteadddel - Add or delete direct route to a local IP address
+ * 
+ * Copyright © 2015-2016 Teddy Hogeborn
+ * Copyright © 2015-2016 Björn Påhlsson
+ * 
+ * This program is free software: you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License as
+ * published by the Free Software Foundation, either version 3 of the
+ * License, or (at your option) any later version.
+ * 
+ * This program is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ * 
+ * You should have received a copy of the GNU General Public License
+ * along with this program.  If not, see
+ * <http://www.gnu.org/licenses/>.
+ * 
+ * Contact the authors at <mandos@recompile.se>.
+ */
+
+#define _GNU_SOURCE		/* asprintf(),
+				   program_invocation_short_name */
+#include <stdbool.h>		/* bool, false, true */
+#include <stdio.h>		/* fprintf(), stderr, FILE, vfprintf */
+#include <errno.h>		/* program_invocation_short_name,
+				   errno, perror(), EINVAL, ENOMEM */
+#include <stdarg.h>		/* va_list, va_start */
+#include <stdlib.h> 		/* EXIT_SUCCESS */
+#include <argp.h>		/* struct argp_option, error_t, struct
+				   argp_state, ARGP_KEY_ARG,
+				   argp_usage(), ARGP_KEY_END,
+				   ARGP_ERR_UNKNOWN, struct argp,
+				   argp_parse() */
+#include <sysexits.h>		/* EX_USAGE, EX_OSERR */
+#include <netinet/ip.h>		/* sa_family_t, AF_INET6, AF_INET */
+#include <inttypes.h>		/* PRIdMAX, intmax_t */
+
+#include <netlink/netlink.h>	/* struct nl_addr, nl_addr_parse(),
+				   nl_geterror(),
+				   nl_addr_get_family(),
+				   nl_addr_put() */
+#include <netlink/route/route.h> /* struct rtnl_route,
+				    struct rtnl_nexthop,
+				    rtnl_route_alloc(),
+				    rtnl_route_set_family(),
+				    rtnl_route_set_protocol(),
+				    RTPROT_BOOT,
+				    rtnl_route_set_scope(),
+				    RT_SCOPE_LINK,
+				    rtnl_route_set_type(),
+				    RTN_UNICAST,
+				    rtnl_route_set_dst(),
+				    rtnl_route_set_table(),
+				    RT_TABLE_MAIN,
+				    rtnl_route_nh_alloc(),
+				    rtnl_route_nh_set_ifindex(),
+				    rtnl_route_add_nexthop(),
+				    rtnl_route_add(),
+				    rtnl_route_delete(),
+				    rtnl_route_put(),
+				    rtnl_route_nh_free() */
+#include <netlink/socket.h>	/* struct nl_sock, nl_socket_alloc(),
+				   nl_connect(), nl_socket_free() */
+#include <netlink/route/link.h>	/* rtnl_link_get_kernel(),
+				   rtnl_link_get_ifindex(),
+				   rtnl_link_put() */
+
+bool debug = false;
+const char *argp_program_version = "mandos-client-iprouteadddel " VERSION;
+const char *argp_program_bug_address = "<mandos@recompile.se>";
+
+/* Function to use when printing errors */
+void perror_plus(const char *print_text){
+  int e = errno;
+  fprintf(stderr, "Mandos plugin helper %s: ",
+	  program_invocation_short_name);
+  errno = e;
+  perror(print_text);
+}
+
+__attribute__((format (gnu_printf, 2, 3), nonnull))
+int fprintf_plus(FILE *stream, const char *format, ...){
+  va_list ap;
+  va_start (ap, format);
+  
+  fprintf(stream, "Mandos plugin helper %s: ",
+	  program_invocation_short_name);
+  return vfprintf(stream, format, ap);
+}
+
+int main(int argc, char *argv[]){
+  int ret;
+  int exitcode = EXIT_SUCCESS;
+  struct arguments {
+    bool add;			/* true: add, false: delete */
+    char *address;		/* IP address as string */
+    struct nl_addr *nl_addr;	/* Netlink IP address */
+    char *interface;		/* interface name */
+  } arguments = { .add = true, .address = NULL, .interface = NULL };
+  struct argp_option options[] = {
+    { .name = "debug", .key = 128,
+      .doc = "Debug mode" },
+    { .name = NULL }
+  };
+  struct rtnl_route *route = NULL;
+  struct rtnl_nexthop *nexthop = NULL;
+  struct nl_sock *sk = NULL;
+  
+  error_t parse_opt(int key, char *arg, struct argp_state *state){
+    int lret;
+    errno = 0;
+    switch(key){
+    case 128:			/* --debug */
+      debug = true;
+      break;
+    case ARGP_KEY_ARG:
+      switch(state->arg_num){
+      case 0:
+	if(strcasecmp(arg, "add") == 0){
+	  ((struct arguments *)(state->input))->add = true;
+	} else if(strcasecmp(arg, "delete") == 0){
+	  ((struct arguments *)(state->input))->add = false;
+	} else {
+	  fprintf_plus(stderr, "Unrecognized command: %s\n", arg);
+	  argp_usage(state);
+	}
+	break;
+      case 1:
+	((struct arguments *)(state->input))->address = arg;
+	lret = nl_addr_parse(arg, AF_UNSPEC, &(((struct arguments *)
+						(state->input))
+					       ->nl_addr));
+	if(lret != 0){
+	  fprintf_plus(stderr, "Failed to parse address %s: %s\n",
+		       arg, nl_geterror(lret));
+	  argp_usage(state);
+	}
+	break;
+      case 2:
+	((struct arguments *)(state->input))->interface = arg;
+	break;
+      default:
+	argp_usage(state);
+      }
+      break;
+    case ARGP_KEY_END:
+      if(state->arg_num < 3){
+	argp_usage(state);
+      }
+      break;
+    default:
+      return ARGP_ERR_UNKNOWN;
+    }
+    return errno;
+  }
+  
+  struct argp argp = { .options = options, .parser = parse_opt,
+		       .args_doc = "[ add | delete ] ADDRESS INTERFACE",
+		       .doc = "Mandos client helper -- Add or delete"
+		       " local route to IP address on interface" };
+  
+  ret = argp_parse(&argp, argc, argv, ARGP_IN_ORDER, 0, &arguments);
+  switch(ret){
+  case 0:
+    break;
+  case EINVAL:
+    exit(EX_USAGE);
+  case ENOMEM:
+  default:
+    errno = ret;
+    perror_plus("argp_parse");
+    exitcode = EX_OSERR;
+    goto end;
+  }
+  /* Get netlink socket */
+  sk = nl_socket_alloc();
+  if(sk == NULL){
+    fprintf_plus(stderr, "Failed to allocate netlink socket: %s\n",
+		 nl_geterror(ret));
+    exitcode = EX_OSERR;
+    goto end;
+  }
+  /* Connect socket to netlink */
+  ret = nl_connect(sk, NETLINK_ROUTE);
+  if(ret < 0){
+    fprintf_plus(stderr, "Failed to connect socket to netlink: %s\n",
+		 nl_geterror(ret));
+    exitcode = EX_OSERR;
+    goto end;
+  }
+  /* Get link object of specified interface */
+  struct rtnl_link *link = NULL;
+  ret = rtnl_link_get_kernel(sk, 0, arguments.interface, &link);
+  if(ret < 0){
+    fprintf_plus(stderr, "Failed to use interface %s: %s\n",
+		 arguments.interface, nl_geterror(ret));
+    exitcode = EX_OSERR;
+    goto end;
+  }
+  /* Get netlink route object */
+  route = rtnl_route_alloc();
+  if(route == NULL){
+    fprintf_plus(stderr, "Failed to get netlink route:\n");
+    exitcode = EX_OSERR;
+    goto end;
+  }
+  /* Get address family of specified address */
+  sa_family_t af = (sa_family_t)nl_addr_get_family(arguments.nl_addr);
+  if(debug){
+    fprintf_plus(stderr, "Address family of %s is %s (%" PRIdMAX
+		 ")\n", arguments.address,
+		 af == AF_INET6 ? "AF_INET6" :
+		 ( af == AF_INET ? "AF_INET" : "UNKNOWN"),
+		 (intmax_t)af);
+  }
+  /* Set route parameters: */
+  rtnl_route_set_family(route, (uint8_t)af);   /* Address family */
+  rtnl_route_set_protocol(route, RTPROT_BOOT); /* protocol - see
+						  ip-route(8) */
+  rtnl_route_set_scope(route, RT_SCOPE_LINK); /* link scope */
+  rtnl_route_set_type(route, RTN_UNICAST);    /* normal unicast
+						 address route */
+  rtnl_route_set_dst(route, arguments.nl_addr); /* Destination
+						   address */
+  rtnl_route_set_table(route, RT_TABLE_MAIN); /* "main" routing
+						 table */
+  /* Create nexthop */
+  nexthop = rtnl_route_nh_alloc();
+  if(nexthop == NULL){
+    fprintf_plus(stderr, "Failed to get netlink route nexthop\n");
+    exitcode = EX_OSERR;
+    goto end;
+  }
+  /* Get index number of specified interface */
+  int ifindex = rtnl_link_get_ifindex(link);
+  if(debug){
+    fprintf_plus(stderr, "ifindex of %s is %d\n", arguments.interface,
+		 ifindex);
+  }
+  /* Set interface index number on nexthop object */
+  rtnl_route_nh_set_ifindex(nexthop, ifindex);
+  /* Set route tu use nexthop object */
+  rtnl_route_add_nexthop(route, nexthop);
+  /* Add or delete route? */
+  if(arguments.add){
+    ret = rtnl_route_add(sk, route, NLM_F_EXCL);
+  } else {
+    ret = rtnl_route_delete(sk, route, 0);
+  }
+  if(ret < 0){
+     fprintf_plus(stderr, "Failed to %s route: %s\n",
+		  arguments.add ? "add" : "delete",
+		  nl_geterror(ret));
+    exitcode = EX_OSERR;
+    goto end;
+  }
+ end:
+  /* Deallocate route */
+  if(route){
+    rtnl_route_put(route);
+  } else if(nexthop) {
+    /* Deallocate route nexthop */
+    rtnl_route_nh_free(nexthop);
+  }
+  /* Deallocate parsed address */
+  if(arguments.nl_addr){
+    nl_addr_put(arguments.nl_addr);
+  }
+  /* Deallocate link struct */
+  if(link){
+    rtnl_link_put(link);
+  }
+  /* Deallocate netlink socket struct */
+   if(sk){
+    nl_socket_free(sk);
+  }
+  return exitcode;
+}

=== modified file 'plugin-runner.c'
--- plugin-runner.c	2014-07-16 01:41:23 +0000
+++ plugin-runner.c	2016-02-28 14:22:10 +0000
@@ -2,8 +2,8 @@
 /*
  * Mandos plugin runner - Run Mandos plugins
  *
- * Copyright © 2008-2014 Teddy Hogeborn
- * Copyright © 2008-2014 Björn Påhlsson
+ * Copyright © 2008-2016 Teddy Hogeborn
+ * Copyright © 2008-2016 Björn Påhlsson
  * 
  * This program is free software: you can redistribute it and/or
  * modify it under the terms of the GNU General Public License as
@@ -76,6 +76,7 @@
 #define BUFFER_SIZE 256
 
 #define PDIR "/lib/mandos/plugins.d"
+#define PHDIR "/lib/mandos/plugin-helpers"
 #define AFILE "/conf/conf.d/mandos/plugin-runner.conf"
 
 const char *argp_program_version = "plugin-runner " VERSION;
@@ -347,6 +348,7 @@
 
 int main(int argc, char *argv[]){
   char *plugindir = NULL;
+  char *pluginhelperdir = NULL;
   char *argfile = NULL;
   FILE *conffp;
   struct dirent **direntries = NULL;
@@ -414,6 +416,10 @@
       .doc = "Group ID the plugins will run as", .group = 3 },
     { .name = "debug", .key = 132,
       .doc = "Debug mode", .group = 4 },
+    { .name = "plugin-helper-dir", .key = 133,
+      .arg = "DIRECTORY",
+      .doc = "Specify a different plugin helper directory",
+      .group = 2 },
     /*
      * These reproduce what we would get without ARGP_NO_HELP
      */
@@ -545,6 +551,13 @@
     case 132:			/* --debug */
       debug = true;
       break;
+    case 133:			/* --plugin-helper-dir */
+      free(pluginhelperdir);
+      pluginhelperdir = strdup(arg);
+      if(pluginhelperdir != NULL){
+	errno = 0;
+      }
+      break;
       /*
        * These reproduce what we would get without ARGP_NO_HELP
        */
@@ -601,6 +614,7 @@
     case 130:			/* --userid */
     case 131:			/* --groupid */
     case 132:			/* --debug */
+    case 133:			/* --plugin-helper-dir */
     case '?':			/* --help */
     case -3:			/* --usage */
     case 'V':			/* --version */
@@ -687,8 +701,7 @@
 	custom_argc += 1;
 	{
 	  char **new_argv = realloc(custom_argv, sizeof(char *)
-				    * ((unsigned int)
-				       custom_argc + 1));
+				    * ((size_t)custom_argc + 1));
 	  if(new_argv == NULL){
 	    error(0, errno, "realloc");
 	    exitstatus = EX_OSERR;
@@ -761,6 +774,24 @@
     goto fallback;
   }
   
+  {
+    char *pluginhelperenv;
+    bool bret = true;
+    ret = asprintf(&pluginhelperenv, "MANDOSPLUGINHELPERDIR=%s",
+		   pluginhelperdir != NULL ? pluginhelperdir : PHDIR);
+    if(ret != -1){
+      bret = add_environment(getplugin(NULL), pluginhelperenv, true);
+    }
+    if(ret == -1 or not bret){
+      error(0, errno, "Failed to set MANDOSPLUGINHELPERDIR"
+	    " environment variable to \"%s\" for all plugins\n",
+	    pluginhelperdir != NULL ? pluginhelperdir : PHDIR);
+    }
+    if(ret != -1){
+      free(pluginhelperenv);
+    }
+  }
+  
   if(debug){
     for(plugin *p = plugin_list; p != NULL; p=p->next){
       fprintf(stderr, "Plugin: %s has %d arguments\n",
@@ -795,7 +826,7 @@
 	  }
 	}
       }
-      TEMP_FAILURE_RETRY(close(plugindir_fd));
+      close(plugindir_fd);
     }
   }
   
@@ -893,7 +924,7 @@
     ret = (int)TEMP_FAILURE_RETRY(fstat(plugin_fd, &st));
     if(ret == -1){
       error(0, errno, "stat");
-      TEMP_FAILURE_RETRY(close(plugin_fd));
+      close(plugin_fd);
       free(direntries[i]);
       continue;
     }
@@ -908,7 +939,7 @@
 		plugindir != NULL ? plugindir : PDIR,
 		direntries[i]->d_name);
       }
-      TEMP_FAILURE_RETRY(close(plugin_fd));
+      close(plugin_fd);
       free(direntries[i]);
       continue;
     }
@@ -916,7 +947,7 @@
     plugin *p = getplugin(direntries[i]->d_name);
     if(p == NULL){
       error(0, errno, "getplugin");
-      TEMP_FAILURE_RETRY(close(plugin_fd));
+      close(plugin_fd);
       free(direntries[i]);
       continue;
     }
@@ -925,7 +956,7 @@
 	fprintf(stderr, "Ignoring disabled plugin \"%s\"\n",
 		direntries[i]->d_name);
       }
-      TEMP_FAILURE_RETRY(close(plugin_fd));
+      close(plugin_fd);
       free(direntries[i]);
       continue;
     }
@@ -971,8 +1002,8 @@
     if(pipefd[0] >= FD_SETSIZE){
       fprintf(stderr, "pipe()[0] (%d) >= FD_SETSIZE (%d)", pipefd[0],
 	      FD_SETSIZE);
-      TEMP_FAILURE_RETRY(close(pipefd[0]));
-      TEMP_FAILURE_RETRY(close(pipefd[1]));
+      close(pipefd[0]);
+      close(pipefd[1]);
       exitstatus = EX_OSERR;
       free(direntries[i]);
       goto fallback;
@@ -982,8 +1013,8 @@
     ret = set_cloexec_flag(pipefd[0]);
     if(ret < 0){
       error(0, errno, "set_cloexec_flag");
-      TEMP_FAILURE_RETRY(close(pipefd[0]));
-      TEMP_FAILURE_RETRY(close(pipefd[1]));
+      close(pipefd[0]);
+      close(pipefd[1]);
       exitstatus = EX_OSERR;
       free(direntries[i]);
       goto fallback;
@@ -991,8 +1022,8 @@
     ret = set_cloexec_flag(pipefd[1]);
     if(ret < 0){
       error(0, errno, "set_cloexec_flag");
-      TEMP_FAILURE_RETRY(close(pipefd[0]));
-      TEMP_FAILURE_RETRY(close(pipefd[1]));
+      close(pipefd[0]);
+      close(pipefd[1]);
       exitstatus = EX_OSERR;
       free(direntries[i]);
       goto fallback;
@@ -1017,8 +1048,8 @@
       error(0, errno, "fork");
       TEMP_FAILURE_RETRY(sigprocmask(SIG_UNBLOCK,
 				     &sigchld_action.sa_mask, NULL));
-      TEMP_FAILURE_RETRY(close(pipefd[0]));
-      TEMP_FAILURE_RETRY(close(pipefd[1]));
+      close(pipefd[0]);
+      close(pipefd[1]);
       exitstatus = EX_OSERR;
       free(direntries[i]);
       goto fallback;
@@ -1052,9 +1083,8 @@
       /* no return */
     }
     /* Parent process */
-    TEMP_FAILURE_RETRY(close(pipefd[1])); /* Close unused write end of
-					     pipe */
-    TEMP_FAILURE_RETRY(close(plugin_fd));
+    close(pipefd[1]);		/* Close unused write end of pipe */
+    close(plugin_fd);
     plugin *new_plugin = getplugin(direntries[i]->d_name);
     if(new_plugin == NULL){
       error(0, errno, "getplugin");
@@ -1106,7 +1136,7 @@
   
   free(direntries);
   direntries = NULL;
-  TEMP_FAILURE_RETRY(close(dir_fd));
+  close(dir_fd);
   dir_fd = -1;
   free_plugin(getplugin(NULL));
   
@@ -1310,7 +1340,7 @@
   free(direntries);
   
   if(dir_fd != -1){
-    TEMP_FAILURE_RETRY(close(dir_fd));
+    close(dir_fd);
   }
   
   /* Kill the processes */
@@ -1336,6 +1366,7 @@
   free_plugin_list();
   
   free(plugindir);
+  free(pluginhelperdir);
   free(argfile);
   
   return exitstatus;

=== modified file 'plugin-runner.xml'
--- plugin-runner.xml	2011-12-31 23:05:34 +0000
+++ plugin-runner.xml	2016-02-28 14:22:10 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "plugin-runner">
-<!ENTITY TIMESTAMP "2012-01-01">
+<!ENTITY TIMESTAMP "2016-02-28">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -33,7 +33,13 @@
     <copyright>
       <year>2008</year>
       <year>2009</year>
+      <year>2010</year>
+      <year>2011</year>
       <year>2012</year>
+      <year>2013</year>
+      <year>2014</year>
+      <year>2015</year>
+      <year>2016</year>
       <holder>Teddy Hogeborn</holder>
       <holder>Björn Påhlsson</holder>
     </copyright>
@@ -114,6 +120,9 @@
       <arg><option>--plugin-dir=<replaceable
       >DIRECTORY</replaceable></option></arg>
       <sbr/>
+      <arg><option>--plugin-helper-dir=<replaceable
+      >DIRECTORY</replaceable></option></arg>
+      <sbr/>
       <arg><option>--config-file=<replaceable
       >FILE</replaceable></option></arg>
       <sbr/>
@@ -320,6 +329,21 @@
       </varlistentry>
       
       <varlistentry>
+	<term><option>--plugin-helper-dir
+	<replaceable>DIRECTORY</replaceable></option></term>
+	<listitem>
+	  <para>
+	    Specify a different plugin helper directory.  The default
+	    is <filename>/lib/mandos/plugin-helpers</filename>, which
+	    will exist in the initial <acronym>RAM</acronym> disk
+	    environment.  (This will simply be passed to all plugins
+	    via the <envar>MANDOSPLUGINHELPERDIR</envar> environment
+	    variable.  See <xref linkend="writing_plugins"/>)
+	  </para>
+	</listitem>
+      </varlistentry>
+      
+      <varlistentry>
 	<term><option>--config-file
 	<replaceable>FILE</replaceable></option></term>
 	<listitem>
@@ -426,7 +450,11 @@
       <para>
 	The plugin will run in the initial RAM disk environment, so
 	care must be taken not to depend on any files or running
-	services not available there.
+	services not available there.  Any helper executables required
+	by the plugin (which are not in the <envar>PATH</envar>) can
+	be placed in the plugin helper directory, the name of which
+	will be made available to the plugin via the
+	<envar>MANDOSPLUGINHELPERDIR</envar> environment variable.
       </para>
       <para>
 	The plugin must exit cleanly and free all allocated resources
@@ -475,7 +503,9 @@
       only passes on its environment to all the plugins.  The
       environment passed to plugins can be modified using the
       <option>--global-env</option> and <option>--env-for</option>
-      options.
+      options.  Also, the <option>--plugin-helper-dir</option> option
+      will affect the environment variable
+      <envar>MANDOSPLUGINHELPERDIR</envar> for the plugins.
     </para>
   </refsect1>
   
@@ -572,15 +602,16 @@
     </informalexample>
     <informalexample>
       <para>
-	Run plugins from a different directory, read a different
-	configuration file, and add two options to the
+	Read a different configuration file, run plugins from a
+	different directory, specify an alternate plugin helper
+	directory and add two options to the
 	<citerefentry><refentrytitle >mandos-client</refentrytitle>
 	<manvolnum>8mandos</manvolnum></citerefentry> plugin:
       </para>
       <para>
 
 <!-- do not wrap this line -->
-<userinput>cd /etc/keys/mandos; &COMMANDNAME;  --config-file=/etc/mandos/plugin-runner.conf --plugin-dir /usr/lib/mandos/plugins.d --options-for=mandos-client:--pubkey=pubkey.txt,--seckey=seckey.txt</userinput>
+<userinput>cd /etc/keys/mandos; &COMMANDNAME;  --config-file=/etc/mandos/plugin-runner.conf --plugin-dir /usr/lib/x86_64-linux-gnu/mandos/plugins.d --plugin-helper-dir /usr/lib/x86_64-linux-gnu/mandos/plugin-helpers --options-for=mandos-client:--pubkey=pubkey.txt,--seckey=seckey.txt</userinput>
 
       </para>
     </informalexample>

=== modified file 'plugins.d/askpass-fifo.c'
--- plugins.d/askpass-fifo.c	2014-08-09 23:37:07 +0000
+++ plugins.d/askpass-fifo.c	2016-02-28 14:22:10 +0000
@@ -2,8 +2,8 @@
 /*
  * Askpass-FIFO - Read a password from a FIFO and output it
  * 
- * Copyright © 2008-2014 Teddy Hogeborn
- * Copyright © 2008-2014 Björn Påhlsson
+ * Copyright © 2008-2016 Teddy Hogeborn
+ * Copyright © 2008-2016 Björn Påhlsson
  * 
  * This program is free software: you can redistribute it and/or
  * modify it under the terms of the GNU General Public License as

=== modified file 'plugins.d/askpass-fifo.xml'
--- plugins.d/askpass-fifo.xml	2011-12-31 23:05:34 +0000
+++ plugins.d/askpass-fifo.xml	2016-02-28 14:22:10 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "askpass-fifo">
-<!ENTITY TIMESTAMP "2012-01-01">
+<!ENTITY TIMESTAMP "2016-02-28">
 <!ENTITY % common SYSTEM "../common.ent">
 %common;
 ]>
@@ -33,8 +33,13 @@
     <copyright>
       <year>2008</year>
       <year>2009</year>
+      <year>2010</year>
       <year>2011</year>
       <year>2012</year>
+      <year>2013</year>
+      <year>2014</year>
+      <year>2015</year>
+      <year>2016</year>
       <holder>Teddy Hogeborn</holder>
       <holder>Björn Påhlsson</holder>
     </copyright>

=== modified file 'plugins.d/mandos-client.c'
--- plugins.d/mandos-client.c	2015-03-10 18:52:09 +0000
+++ plugins.d/mandos-client.c	2016-02-28 14:22:10 +0000
@@ -9,8 +9,8 @@
  * "browse_callback", and parts of "main".
  * 
  * Everything else is
- * Copyright © 2008-2014 Teddy Hogeborn
- * Copyright © 2008-2014 Björn Påhlsson
+ * Copyright © 2008-2016 Teddy Hogeborn
+ * Copyright © 2008-2016 Björn Påhlsson
  * 
  * This program is free software: you can redistribute it and/or
  * modify it under the terms of the GNU General Public License as
@@ -46,8 +46,8 @@
 #include <stdlib.h> 		/* free(), EXIT_SUCCESS, srand(),
 				   strtof(), abort() */
 #include <stdbool.h>		/* bool, false, true */
-#include <string.h>		/* memset(), strcmp(), strlen(),
-				   strerror(), asprintf(), strcpy() */
+#include <string.h>		/* strcmp(), strlen(), strerror(),
+				   asprintf(), strncpy() */
 #include <sys/ioctl.h>		/* ioctl */
 #include <sys/types.h>		/* socket(), inet_pton(), sockaddr,
 				   sockaddr_in6, PF_INET6,
@@ -305,7 +305,7 @@
       return false;
     }
     
-    ret = (int)TEMP_FAILURE_RETRY(close(fd));
+    ret = close(fd);
     if(ret == -1){
       perror_plus("close");
     }
@@ -516,6 +516,7 @@
 __attribute__((nonnull, warn_unused_result))
 static int init_gnutls_global(const char *pubkeyfilename,
 			      const char *seckeyfilename,
+			      const char *dhparamsfilename,
 			      mandos_context *mc){
   int ret;
   unsigned int uret;
@@ -575,24 +576,30 @@
 		 safer_gnutls_strerror(ret));
     goto globalfail;
   }
-  if(mc->dh_bits == 0){
-    /* Find out the optimal number of DH bits */
-    /* Try to read the private key file */
-    gnutls_datum_t buffer = { .data = NULL, .size = 0 };
-    {
-      int secfile = open(seckeyfilename, O_RDONLY);
-      size_t buffer_capacity = 0;
+  /* If a Diffie-Hellman parameters file was given, try to use it */
+  if(dhparamsfilename != NULL){
+    gnutls_datum_t params = { .data = NULL, .size = 0 };
+    do {
+      int dhpfile = open(dhparamsfilename, O_RDONLY);
+      if(dhpfile == -1){
+	perror_plus("open");
+	dhparamsfilename = NULL;
+	break;
+      }
+      size_t params_capacity = 0;
       while(true){
-	buffer_capacity = incbuffer((char **)&buffer.data,
-				    (size_t)buffer.size,
-				    (size_t)buffer_capacity);
-	if(buffer_capacity == 0){
+	params_capacity = incbuffer((char **)&params.data,
+				    (size_t)params.size,
+				    (size_t)params_capacity);
+	if(params_capacity == 0){
 	  perror_plus("incbuffer");
-	  free(buffer.data);
-	  buffer.data = NULL;
+	  free(params.data);
+	  params.data = NULL;
+	  dhparamsfilename = NULL;
 	  break;
 	}
-	ssize_t bytes_read = read(secfile, buffer.data + buffer.size,
+	ssize_t bytes_read = read(dhpfile,
+				  params.data + params.size,
 				  BUFFER_SIZE);
 	/* EOF */
 	if(bytes_read == 0){
@@ -601,88 +608,146 @@
 	/* check bytes_read for failure */
 	if(bytes_read < 0){
 	  perror_plus("read");
-	  free(buffer.data);
-	  buffer.data = NULL;
-	  break;
-	}
-	buffer.size += (unsigned int)bytes_read;
-      }
-      close(secfile);
-    }
-    /* If successful, use buffer to parse private key */
-    gnutls_sec_param_t sec_param = GNUTLS_SEC_PARAM_ULTRA;
-    if(buffer.data != NULL){
-      {
-	gnutls_openpgp_privkey_t privkey = NULL;
-	ret = gnutls_openpgp_privkey_init(&privkey);
-	if(ret != GNUTLS_E_SUCCESS){
-	  fprintf_plus(stderr, "Error initializing OpenPGP key"
-		       " structure: %s", safer_gnutls_strerror(ret));
-	  free(buffer.data);
-	  buffer.data = NULL;
-	} else {
-	  ret = gnutls_openpgp_privkey_import(privkey, &buffer,
-					    GNUTLS_OPENPGP_FMT_BASE64,
-					      "", 0);
+	  free(params.data);
+	  params.data = NULL;
+	  dhparamsfilename = NULL;
+	  break;
+	}
+	params.size += (unsigned int)bytes_read;
+      }
+      if(params.data == NULL){
+	dhparamsfilename = NULL;
+      }
+      if(dhparamsfilename == NULL){
+	break;
+      }
+      ret = gnutls_dh_params_import_pkcs3(mc->dh_params, &params,
+					  GNUTLS_X509_FMT_PEM);
+      if(ret != GNUTLS_E_SUCCESS){
+	fprintf_plus(stderr, "Failed to parse DH parameters in file"
+		     " \"%s\": %s\n", dhparamsfilename,
+		     safer_gnutls_strerror(ret));
+	dhparamsfilename = NULL;
+      }
+    } while(false);
+  }
+  if(dhparamsfilename == NULL){
+    if(mc->dh_bits == 0){
+      /* Find out the optimal number of DH bits */
+      /* Try to read the private key file */
+      gnutls_datum_t buffer = { .data = NULL, .size = 0 };
+      do {
+	int secfile = open(seckeyfilename, O_RDONLY);
+	if(secfile == -1){
+	  perror_plus("open");
+	  break;
+	}
+	size_t buffer_capacity = 0;
+	while(true){
+	  buffer_capacity = incbuffer((char **)&buffer.data,
+				      (size_t)buffer.size,
+				      (size_t)buffer_capacity);
+	  if(buffer_capacity == 0){
+	    perror_plus("incbuffer");
+	    free(buffer.data);
+	    buffer.data = NULL;
+	    break;
+	  }
+	  ssize_t bytes_read = read(secfile,
+				    buffer.data + buffer.size,
+				    BUFFER_SIZE);
+	  /* EOF */
+	  if(bytes_read == 0){
+	    break;
+	  }
+	  /* check bytes_read for failure */
+	  if(bytes_read < 0){
+	    perror_plus("read");
+	    free(buffer.data);
+	    buffer.data = NULL;
+	    break;
+	  }
+	  buffer.size += (unsigned int)bytes_read;
+	}
+	close(secfile);
+      } while(false);
+      /* If successful, use buffer to parse private key */
+      gnutls_sec_param_t sec_param = GNUTLS_SEC_PARAM_ULTRA;
+      if(buffer.data != NULL){
+	{
+	  gnutls_openpgp_privkey_t privkey = NULL;
+	  ret = gnutls_openpgp_privkey_init(&privkey);
 	  if(ret != GNUTLS_E_SUCCESS){
-	    fprintf_plus(stderr, "Error importing OpenPGP key : %s",
+	    fprintf_plus(stderr, "Error initializing OpenPGP key"
+			 " structure: %s",
 			 safer_gnutls_strerror(ret));
-	    privkey = NULL;
+	    free(buffer.data);
+	    buffer.data = NULL;
+	  } else {
+	    ret = gnutls_openpgp_privkey_import
+	      (privkey, &buffer, GNUTLS_OPENPGP_FMT_BASE64, "", 0);
+	    if(ret != GNUTLS_E_SUCCESS){
+	      fprintf_plus(stderr, "Error importing OpenPGP key : %s",
+			   safer_gnutls_strerror(ret));
+	      privkey = NULL;
+	    }
+	    free(buffer.data);
+	    buffer.data = NULL;
+	    if(privkey != NULL){
+	      /* Use private key to suggest an appropriate
+		 sec_param */
+	      sec_param = gnutls_openpgp_privkey_sec_param(privkey);
+	      gnutls_openpgp_privkey_deinit(privkey);
+	      if(debug){
+		fprintf_plus(stderr, "This OpenPGP key implies using"
+			     " a GnuTLS security parameter \"%s\".\n",
+			     safe_string(gnutls_sec_param_get_name
+					 (sec_param)));
+	      }
+	    }
 	  }
-	  free(buffer.data);
-	  buffer.data = NULL;
-	  if(privkey != NULL){
-	    /* Use private key to suggest an appropriate sec_param */
-	    sec_param = gnutls_openpgp_privkey_sec_param(privkey);
-	    gnutls_openpgp_privkey_deinit(privkey);
-	    if(debug){
-	      fprintf_plus(stderr, "This OpenPGP key implies using a"
-			   " GnuTLS security parameter \"%s\".\n",
-			   safe_string(gnutls_sec_param_get_name
-				       (sec_param)));
-	    }
+	}
+	if(sec_param == GNUTLS_SEC_PARAM_UNKNOWN){
+	  /* Err on the side of caution */
+	  sec_param = GNUTLS_SEC_PARAM_ULTRA;
+	  if(debug){
+	    fprintf_plus(stderr, "Falling back to security parameter"
+			 " \"%s\"\n",
+			 safe_string(gnutls_sec_param_get_name
+				     (sec_param)));
 	  }
 	}
       }
-      if(sec_param == GNUTLS_SEC_PARAM_UNKNOWN){
-	/* Err on the side of caution */
-	sec_param = GNUTLS_SEC_PARAM_ULTRA;
+      uret = gnutls_sec_param_to_pk_bits(GNUTLS_PK_DH, sec_param);
+      if(uret != 0){
+	mc->dh_bits = uret;
 	if(debug){
-	  fprintf_plus(stderr, "Falling back to security parameter"
-		       " \"%s\"\n",
+	  fprintf_plus(stderr, "A \"%s\" GnuTLS security parameter"
+		       " implies %u DH bits; using that.\n",
 		       safe_string(gnutls_sec_param_get_name
-				   (sec_param)));
+				   (sec_param)),
+		       mc->dh_bits);
 	}
-      }
-    }
-    uret = gnutls_sec_param_to_pk_bits(GNUTLS_PK_DH, sec_param);
-    if(uret != 0){
-      mc->dh_bits = uret;
-      if(debug){
-	fprintf_plus(stderr, "A \"%s\" GnuTLS security parameter"
-		     " implies %u DH bits; using that.\n",
+      } else {
+	fprintf_plus(stderr, "Failed to get implied number of DH"
+		     " bits for security parameter \"%s\"): %s\n",
 		     safe_string(gnutls_sec_param_get_name
 				 (sec_param)),
-		     mc->dh_bits);
+		     safer_gnutls_strerror(ret));
+	goto globalfail;
       }
-    } else {
-      fprintf_plus(stderr, "Failed to get implied number of DH"
-		   " bits for security parameter \"%s\"): %s\n",
-		   safe_string(gnutls_sec_param_get_name(sec_param)),
+    } else if(debug){
+      fprintf_plus(stderr, "DH bits explicitly set to %u\n",
+		   mc->dh_bits);
+    }
+    ret = gnutls_dh_params_generate2(mc->dh_params, mc->dh_bits);
+    if(ret != GNUTLS_E_SUCCESS){
+      fprintf_plus(stderr, "Error in GnuTLS prime generation (%u"
+		   " bits): %s\n", mc->dh_bits,
 		   safer_gnutls_strerror(ret));
       goto globalfail;
     }
-  } else if(debug){
-    fprintf_plus(stderr, "DH bits explicitly set to %u\n",
-		 mc->dh_bits);
-  }
-  ret = gnutls_dh_params_generate2(mc->dh_params, mc->dh_bits);
-  if(ret != GNUTLS_E_SUCCESS){
-    fprintf_plus(stderr, "Error in GnuTLS prime generation (%u bits):"
-		 " %s\n", mc->dh_bits, safer_gnutls_strerror(ret));
-    goto globalfail;
-  }
-  
+  }
   gnutls_certificate_set_dh_params(mc->cred, mc->dh_params);
   
   return 0;
@@ -748,8 +813,6 @@
   /* ignore client certificate if any. */
   gnutls_certificate_server_set_request(*session, GNUTLS_CERT_IGNORE);
   
-  gnutls_dh_set_prime_bits(*session, mc->dh_bits);
-  
   return 0;
 }
 
@@ -757,6 +820,224 @@
 static void empty_log(__attribute__((unused)) AvahiLogLevel level,
 		      __attribute__((unused)) const char *txt){}
 
+/* Set effective uid to 0, return errno */
+__attribute__((warn_unused_result))
+error_t raise_privileges(void){
+  error_t old_errno = errno;
+  error_t ret_errno = 0;
+  if(seteuid(0) == -1){
+    ret_errno = errno;
+  }
+  errno = old_errno;
+  return ret_errno;
+}
+
+/* Set effective and real user ID to 0.  Return errno. */
+__attribute__((warn_unused_result))
+error_t raise_privileges_permanently(void){
+  error_t old_errno = errno;
+  error_t ret_errno = raise_privileges();
+  if(ret_errno != 0){
+    errno = old_errno;
+    return ret_errno;
+  }
+  if(setuid(0) == -1){
+    ret_errno = errno;
+  }
+  errno = old_errno;
+  return ret_errno;
+}
+
+/* Set effective user ID to unprivileged saved user ID */
+__attribute__((warn_unused_result))
+error_t lower_privileges(void){
+  error_t old_errno = errno;
+  error_t ret_errno = 0;
+  if(seteuid(uid) == -1){
+    ret_errno = errno;
+  }
+  errno = old_errno;
+  return ret_errno;
+}
+
+/* Lower privileges permanently */
+__attribute__((warn_unused_result))
+error_t lower_privileges_permanently(void){
+  error_t old_errno = errno;
+  error_t ret_errno = 0;
+  if(setuid(uid) == -1){
+    ret_errno = errno;
+  }
+  errno = old_errno;
+  return ret_errno;
+}
+
+/* Helper function to add_local_route() and delete_local_route() */
+__attribute__((nonnull, warn_unused_result))
+static bool add_delete_local_route(const bool add,
+				   const char *address,
+				   AvahiIfIndex if_index){
+  int ret;
+  char helper[] = "mandos-client-iprouteadddel";
+  char add_arg[] = "add";
+  char delete_arg[] = "delete";
+  char debug_flag[] = "--debug";
+  char *pluginhelperdir = getenv("MANDOSPLUGINHELPERDIR");
+  if(pluginhelperdir == NULL){
+    if(debug){
+      fprintf_plus(stderr, "MANDOSPLUGINHELPERDIR environment"
+		   " variable not set; cannot run helper\n");
+    }
+    return false;
+  }
+  
+  char interface[IF_NAMESIZE];
+  if(if_indextoname((unsigned int)if_index, interface) == NULL){
+    perror_plus("if_indextoname");
+    return false;
+  }
+  
+  int devnull = (int)TEMP_FAILURE_RETRY(open("/dev/null", O_RDONLY));
+  if(devnull == -1){
+    perror_plus("open(\"/dev/null\", O_RDONLY)");
+    return false;
+  }
+  pid_t pid = fork();
+  if(pid == 0){
+    /* Child */
+    /* Raise privileges */
+    errno = raise_privileges_permanently();
+    if(errno != 0){
+      perror_plus("Failed to raise privileges");
+      /* _exit(EX_NOPERM); */
+    } else {
+      /* Set group */
+      errno = 0;
+      ret = setgid(0);
+      if(ret == -1){
+	perror_plus("setgid");
+	_exit(EX_NOPERM);
+      }
+      /* Reset supplementary groups */
+      errno = 0;
+      ret = setgroups(0, NULL);
+      if(ret == -1){
+	perror_plus("setgroups");
+	_exit(EX_NOPERM);
+      }
+    }
+    ret = dup2(devnull, STDIN_FILENO);
+    if(ret == -1){
+      perror_plus("dup2(devnull, STDIN_FILENO)");
+      _exit(EX_OSERR);
+    }
+    ret = close(devnull);
+    if(ret == -1){
+      perror_plus("close");
+      _exit(EX_OSERR);
+    }
+    ret = dup2(STDERR_FILENO, STDOUT_FILENO);
+    if(ret == -1){
+      perror_plus("dup2(STDERR_FILENO, STDOUT_FILENO)");
+      _exit(EX_OSERR);
+    }
+    int helperdir_fd = (int)TEMP_FAILURE_RETRY(open(pluginhelperdir,
+						    O_RDONLY
+						    | O_DIRECTORY
+						    | O_PATH
+						    | O_CLOEXEC));
+    if(helperdir_fd == -1){
+      perror_plus("open");
+      _exit(EX_UNAVAILABLE);
+    }
+    int helper_fd = (int)TEMP_FAILURE_RETRY(openat(helperdir_fd,
+						   helper, O_RDONLY));
+    if(helper_fd == -1){
+      perror_plus("openat");
+      close(helperdir_fd);
+      _exit(EX_UNAVAILABLE);
+    }
+    close(helperdir_fd);
+#ifdef __GNUC__
+#pragma GCC diagnostic push
+#pragma GCC diagnostic ignored "-Wcast-qual"
+#endif
+    if(fexecve(helper_fd, (char *const [])
+	       { helper, add ? add_arg : delete_arg, (char *)address,
+		   interface, debug ? debug_flag : NULL, NULL },
+	       environ) == -1){
+#ifdef __GNUC__
+#pragma GCC diagnostic pop
+#endif
+      perror_plus("fexecve");
+      _exit(EXIT_FAILURE);
+    }
+  }
+  if(pid == -1){
+    perror_plus("fork");
+    return false;
+  }
+  int status;
+  pid_t pret = -1;
+  errno = 0;
+  do {
+    pret = waitpid(pid, &status, 0);
+    if(pret == -1 and errno == EINTR and quit_now){
+      int errno_raising = 0;
+      if((errno = raise_privileges()) != 0){
+	errno_raising = errno;
+	perror_plus("Failed to raise privileges in order to"
+		    " kill helper program");
+      }
+      if(kill(pid, SIGTERM) == -1){
+	perror_plus("kill");
+      }
+      if((errno_raising == 0) and (errno = lower_privileges()) != 0){
+	perror_plus("Failed to lower privileges after killing"
+		    " helper program");
+      }
+      return false;
+    }
+  } while(pret == -1 and errno == EINTR);
+  if(pret == -1){
+    perror_plus("waitpid");
+    return false;
+  }
+  if(WIFEXITED(status)){
+    if(WEXITSTATUS(status) != 0){
+      fprintf_plus(stderr, "Error: iprouteadddel exited"
+		   " with status %d\n", WEXITSTATUS(status));
+      return false;
+    }
+    return true;
+  }
+  if(WIFSIGNALED(status)){
+    fprintf_plus(stderr, "Error: iprouteadddel died by"
+		 " signal %d\n", WTERMSIG(status));
+    return false;
+  }
+  fprintf_plus(stderr, "Error: iprouteadddel crashed\n");
+  return false;
+}
+
+__attribute__((nonnull, warn_unused_result))
+static bool add_local_route(const char *address,
+			    AvahiIfIndex if_index){
+  if(debug){
+    fprintf_plus(stderr, "Adding route to %s\n", address);
+  }
+  return add_delete_local_route(true, address, if_index);
+}
+
+__attribute__((nonnull, warn_unused_result))
+static bool delete_local_route(const char *address,
+			       AvahiIfIndex if_index){
+  if(debug){
+    fprintf_plus(stderr, "Removing route to %s\n", address);
+  }
+  return add_delete_local_route(false, address, if_index);
+}
+
 /* Called when a Mandos server is found */
 __attribute__((nonnull, warn_unused_result))
 static int start_mandos_communication(const char *ip, in_port_t port,
@@ -773,6 +1054,7 @@
   int retval = -1;
   gnutls_session_t session;
   int pf;			/* Protocol family */
+  bool route_added = false;
   
   errno = 0;
   
@@ -836,7 +1118,7 @@
 		 PRIuMAX "\n", ip, (uintmax_t)port);
   }
   
-  tcp_sd = socket(pf, SOCK_STREAM, 0);
+  tcp_sd = socket(pf, SOCK_STREAM | SOCK_CLOEXEC, 0);
   if(tcp_sd < 0){
     int e = errno;
     perror_plus("socket");
@@ -849,13 +1131,14 @@
     goto mandos_end;
   }
   
-  memset(&to, 0, sizeof(to));
   if(af == AF_INET6){
-    ((struct sockaddr_in6 *)&to)->sin6_family = (sa_family_t)af;
-    ret = inet_pton(af, ip, &((struct sockaddr_in6 *)&to)->sin6_addr);
+    struct sockaddr_in6 *to6 = (struct sockaddr_in6 *)&to;
+    *to6 = (struct sockaddr_in6){ .sin6_family = (sa_family_t)af };
+    ret = inet_pton(af, ip, &to6->sin6_addr);
   } else {			/* IPv4 */
-    ((struct sockaddr_in *)&to)->sin_family = (sa_family_t)af;
-    ret = inet_pton(af, ip, &((struct sockaddr_in *)&to)->sin_addr);
+    struct sockaddr_in *to4 = (struct sockaddr_in *)&to;
+    *to4 = (struct sockaddr_in){ .sin_family = (sa_family_t)af };
+    ret = inet_pton(af, ip, &to4->sin_addr);
   }
   if(ret < 0 ){
     int e = errno;
@@ -931,25 +1214,61 @@
     goto mandos_end;
   }
   
-  if(af == AF_INET6){
-    ret = connect(tcp_sd, (struct sockaddr *)&to,
-		  sizeof(struct sockaddr_in6));
-  } else {
-    ret = connect(tcp_sd, (struct sockaddr *)&to, /* IPv4 */
-		  sizeof(struct sockaddr_in));
-  }
-  if(ret < 0){
-    if((errno != ECONNREFUSED and errno != ENETUNREACH) or debug){
-      int e = errno;
-      perror_plus("connect");
-      errno = e;
-    }
-    goto mandos_end;
-  }
-  
-  if(quit_now){
-    errno = EINTR;
-    goto mandos_end;
+  while(true){
+    if(af == AF_INET6){
+      ret = connect(tcp_sd, (struct sockaddr *)&to,
+		    sizeof(struct sockaddr_in6));
+    } else {
+      ret = connect(tcp_sd, (struct sockaddr *)&to, /* IPv4 */
+		    sizeof(struct sockaddr_in));
+    }
+    if(ret < 0){
+      if(((errno == ENETUNREACH) or (errno == EHOSTUNREACH))
+	 and if_index != AVAHI_IF_UNSPEC
+	 and connect_to == NULL
+	 and not route_added and
+	 ((af == AF_INET6 and not
+	   IN6_IS_ADDR_LINKLOCAL(&(((struct sockaddr_in6 *)
+				    &to)->sin6_addr)))
+	  or (af == AF_INET and
+	      /* Not a a IPv4LL address */
+	      (ntohl(((struct sockaddr_in *)&to)->sin_addr.s_addr)
+	       & 0xFFFF0000L) != 0xA9FE0000L))){
+	/* Work around Avahi bug - Avahi does not announce link-local
+	   addresses if it has a global address, so local hosts with
+	   *only* a link-local address (e.g. Mandos clients) cannot
+	   connect to a Mandos server announced by Avahi on a server
+	   host with a global address.  Work around this by retrying
+	   with an explicit route added with the server's address.
+	   
+	   Avahi bug reference:
+	   http://lists.freedesktop.org/archives/avahi/2010-February/001833.html
+	   https://bugs.debian.org/587961
+	*/
+	if(debug){
+	  fprintf_plus(stderr, "Mandos server unreachable, trying"
+		       " direct route\n");
+	}
+	int e = errno;
+	route_added = add_local_route(ip, if_index);
+	if(route_added){
+	  continue;
+	}
+	errno = e;
+      }
+      if(errno != ECONNREFUSED or debug){
+	int e = errno;
+	perror_plus("connect");
+	errno = e;
+      }
+      goto mandos_end;
+    }
+    
+    if(quit_now){
+      errno = EINTR;
+      goto mandos_end;
+    }
+    break;
   }
   
   const char *out = mandos_protocol_version;
@@ -1138,11 +1457,17 @@
   
  mandos_end:
   {
+    if(route_added){
+      if(not delete_local_route(ip, if_index)){
+	fprintf_plus(stderr, "Failed to delete local route to %s on"
+		     " interface %d", ip, if_index);
+      }
+    }
     int e = errno;
     free(decrypted_buffer);
     free(buffer);
     if(tcp_sd >= 0){
-      ret = (int)TEMP_FAILURE_RETRY(close(tcp_sd));
+      ret = close(tcp_sd);
     }
     if(ret == -1){
       if(e == 0){
@@ -1312,7 +1637,8 @@
     errno = ret_errno;
     return false;
   }
-  strcpy(ifr->ifr_name, ifname);
+  strncpy(ifr->ifr_name, ifname, IF_NAMESIZE);
+  ifr->ifr_name[IF_NAMESIZE-1] = '\0'; /* NUL terminate */
   ret = ioctl(s, SIOCGIFFLAGS, ifr);
   if(ret == -1){
     if(debug){
@@ -1569,64 +1895,13 @@
   }
 }
 
-/* Set effective uid to 0, return errno */
-__attribute__((warn_unused_result))
-error_t raise_privileges(void){
-  error_t old_errno = errno;
-  error_t ret_errno = 0;
-  if(seteuid(0) == -1){
-    ret_errno = errno;
-  }
-  errno = old_errno;
-  return ret_errno;
-}
-
-/* Set effective and real user ID to 0.  Return errno. */
-__attribute__((warn_unused_result))
-error_t raise_privileges_permanently(void){
-  error_t old_errno = errno;
-  error_t ret_errno = raise_privileges();
-  if(ret_errno != 0){
-    errno = old_errno;
-    return ret_errno;
-  }
-  if(setuid(0) == -1){
-    ret_errno = errno;
-  }
-  errno = old_errno;
-  return ret_errno;
-}
-
-/* Set effective user ID to unprivileged saved user ID */
-__attribute__((warn_unused_result))
-error_t lower_privileges(void){
-  error_t old_errno = errno;
-  error_t ret_errno = 0;
-  if(seteuid(uid) == -1){
-    ret_errno = errno;
-  }
-  errno = old_errno;
-  return ret_errno;
-}
-
-/* Lower privileges permanently */
-__attribute__((warn_unused_result))
-error_t lower_privileges_permanently(void){
-  error_t old_errno = errno;
-  error_t ret_errno = 0;
-  if(setuid(uid) == -1){
-    ret_errno = errno;
-  }
-  errno = old_errno;
-  return ret_errno;
-}
-
 __attribute__((nonnull))
 void run_network_hooks(const char *mode, const char *interface,
 		       const float delay){
   struct dirent **direntries = NULL;
   if(hookdir_fd == -1){
-    hookdir_fd = open(hookdir, O_RDONLY);
+    hookdir_fd = open(hookdir, O_RDONLY | O_DIRECTORY | O_PATH
+		      | O_CLOEXEC);
     if(hookdir_fd == -1){
       if(errno == ENOENT){
 	if(debug){
@@ -1657,7 +1932,11 @@
   }
   struct dirent *direntry;
   int ret;
-  int devnull = open("/dev/null", O_RDONLY);
+  int devnull = (int)TEMP_FAILURE_RETRY(open("/dev/null", O_RDONLY));
+  if(devnull == -1){
+    perror_plus("open(\"/dev/null\", O_RDONLY)");
+    return;
+  }
   for(int i = 0; i < numhooks; i++){
     direntry = direntries[i];
     if(debug){
@@ -1687,21 +1966,6 @@
 	perror_plus("setgroups");
 	_exit(EX_NOPERM);
       }
-      ret = dup2(devnull, STDIN_FILENO);
-      if(ret == -1){
-	perror_plus("dup2(devnull, STDIN_FILENO)");
-	_exit(EX_OSERR);
-      }
-      ret = close(devnull);
-      if(ret == -1){
-	perror_plus("close");
-	_exit(EX_OSERR);
-      }
-      ret = dup2(STDERR_FILENO, STDOUT_FILENO);
-      if(ret == -1){
-	perror_plus("dup2(STDERR_FILENO, STDOUT_FILENO)");
-	_exit(EX_OSERR);
-      }
       ret = setenv("MANDOSNETHOOKDIR", hookdir, 1);
       if(ret == -1){
 	perror_plus("setenv");
@@ -1742,15 +2006,32 @@
 	  _exit(EX_OSERR);
 	}
       }
-      int hook_fd = openat(hookdir_fd, direntry->d_name, O_RDONLY);
+      int hook_fd = (int)TEMP_FAILURE_RETRY(openat(hookdir_fd,
+						   direntry->d_name,
+						   O_RDONLY));
       if(hook_fd == -1){
 	perror_plus("openat");
 	_exit(EXIT_FAILURE);
       }
-      if((int)TEMP_FAILURE_RETRY(close(hookdir_fd)) == -1){
+      if(close(hookdir_fd) == -1){
 	perror_plus("close");
 	_exit(EXIT_FAILURE);
       }
+      ret = dup2(devnull, STDIN_FILENO);
+      if(ret == -1){
+	perror_plus("dup2(devnull, STDIN_FILENO)");
+	_exit(EX_OSERR);
+      }
+      ret = close(devnull);
+      if(ret == -1){
+	perror_plus("close");
+	_exit(EX_OSERR);
+      }
+      ret = dup2(STDERR_FILENO, STDOUT_FILENO);
+      if(ret == -1){
+	perror_plus("dup2(STDERR_FILENO, STDOUT_FILENO)");
+	_exit(EX_OSERR);
+      }
       if(fexecve(hook_fd, (char *const []){ direntry->d_name, NULL },
 		 environ) == -1){
 	perror_plus("fexecve");
@@ -1796,7 +2077,7 @@
     free(direntry);
   }
   free(direntries);
-  if((int)TEMP_FAILURE_RETRY(close(hookdir_fd)) == -1){
+  if(close(hookdir_fd) == -1){
     perror_plus("close");
   } else {
     hookdir_fd = -1;
@@ -1842,7 +2123,7 @@
     }
     
     if(quit_now){
-      ret = (int)TEMP_FAILURE_RETRY(close(sd));
+      ret = close(sd);
       if(ret == -1){
 	perror_plus("close");
       }
@@ -1898,7 +2179,7 @@
     }
     
     /* Close the socket */
-    ret = (int)TEMP_FAILURE_RETRY(close(sd));
+    ret = close(sd);
     if(ret == -1){
       perror_plus("close");
     }
@@ -1986,7 +2267,7 @@
     }
     
     /* Close the socket */
-    int ret = (int)TEMP_FAILURE_RETRY(close(sd));
+    int ret = close(sd);
     if(ret == -1){
       perror_plus("close");
     }
@@ -2008,9 +2289,10 @@
 
 int main(int argc, char *argv[]){
   mandos_context mc = { .server = NULL, .dh_bits = 0,
-			.priority = "SECURE256:!CTYPE-X.509:"
-			"+CTYPE-OPENPGP:!RSA", .current_server = NULL,
-			.interfaces = NULL, .interfaces_size = 0 };
+			.priority = "SECURE256:!CTYPE-X.509"
+			":+CTYPE-OPENPGP:!RSA:+SIGN-DSA-SHA256",
+			.current_server = NULL, .interfaces = NULL,
+			.interfaces_size = 0 };
   AvahiSServiceBrowser *sb = NULL;
   error_t ret_errno;
   int ret;
@@ -2025,6 +2307,7 @@
   AvahiIfIndex if_index = AVAHI_IF_UNSPEC;
   const char *seckey = PATHDIR "/" SECKEY;
   const char *pubkey = PATHDIR "/" PUBKEY;
+  const char *dh_params_file = NULL;
   char *interfaces_hooks = NULL;
   
   bool gnutls_initialized = false;
@@ -2083,6 +2366,11 @@
 	.doc = "Bit length of the prime number used in the"
 	" Diffie-Hellman key exchange",
 	.group = 2 },
+      { .name = "dh-params", .key = 134,
+	.arg = "FILE",
+	.doc = "PEM-encoded PKCS#3 file with pre-generated parameters"
+	" for the Diffie-Hellman key exchange",
+	.group = 2 },
       { .name = "priority", .key = 130,
 	.arg = "STRING",
 	.doc = "GnuTLS priority string for the TLS handshake",
@@ -2143,6 +2431,9 @@
 	}
 	mc.dh_bits = (typeof(mc.dh_bits))tmpmax;
 	break;
+      case 134:			/* --dh-params */
+	dh_params_file = arg;
+	break;
       case 130:			/* --priority */
 	mc.priority = arg;
 	break;
@@ -2204,7 +2495,7 @@
       goto end;
     }
   }
-    
+  
   {
     /* Work around Debian bug #633582:
        <http://bugs.debian.org/633582> */
@@ -2234,10 +2525,10 @@
 	      }
 	    }
 	  }
-	  TEMP_FAILURE_RETRY(close(seckey_fd));
+	  close(seckey_fd);
 	}
       }
-    
+      
       if(strcmp(pubkey, PATHDIR "/" PUBKEY) == 0){
 	int pubkey_fd = open(pubkey, O_RDONLY);
 	if(pubkey_fd == -1){
@@ -2255,10 +2546,32 @@
 	      }
 	    }
 	  }
-	  TEMP_FAILURE_RETRY(close(pubkey_fd));
-	}
-      }
-    
+	  close(pubkey_fd);
+	}
+      }
+      
+      if(dh_params_file != NULL
+	 and strcmp(dh_params_file, PATHDIR "/dhparams.pem" ) == 0){
+	int dhparams_fd = open(dh_params_file, O_RDONLY);
+	if(dhparams_fd == -1){
+	  perror_plus("open");
+	} else {
+	  ret = (int)TEMP_FAILURE_RETRY(fstat(dhparams_fd, &st));
+	  if(ret == -1){
+	    perror_plus("fstat");
+	  } else {
+	    if(S_ISREG(st.st_mode)
+	       and st.st_uid == 0 and st.st_gid == 0){
+	      ret = fchown(dhparams_fd, uid, gid);
+	      if(ret == -1){
+		perror_plus("fchown");
+	      }
+	    }
+	  }
+	  close(dhparams_fd);
+	}
+      }
+      
       /* Lower privileges */
       ret_errno = lower_privileges();
       if(ret_errno != 0){
@@ -2438,7 +2751,8 @@
       errno = bring_up_interface(interface, delay);
       if(not interface_was_up){
 	if(errno != 0){
-	  perror_plus("Failed to bring up interface");
+	  fprintf_plus(stderr, "Failed to bring up interface \"%s\":"
+		       " %s\n", interface, strerror(errno));
 	} else {
 	  errno = argz_add(&interfaces_to_take_down,
 			   &interfaces_to_take_down_size,
@@ -2467,7 +2781,7 @@
     goto end;
   }
   
-  ret = init_gnutls_global(pubkey, seckey, &mc);
+  ret = init_gnutls_global(pubkey, seckey, dh_params_file, &mc);
   if(ret == -1){
     fprintf_plus(stderr, "init_gnutls_global failed\n");
     exitcode = EX_UNAVAILABLE;
@@ -2733,8 +3047,10 @@
   /* Removes the GPGME temp directory and all files inside */
   if(tempdir != NULL){
     struct dirent **direntries = NULL;
-    int tempdir_fd = (int)TEMP_FAILURE_RETRY(open(tempdir, O_RDONLY |
-						  O_NOFOLLOW));
+    int tempdir_fd = (int)TEMP_FAILURE_RETRY(open(tempdir, O_RDONLY
+						  | O_NOFOLLOW
+						  | O_DIRECTORY
+						  | O_PATH));
     if(tempdir_fd == -1){
       perror_plus("open");
     } else {
@@ -2771,7 +3087,7 @@
 	  perror_plus("rmdir");
 	}
       }
-      TEMP_FAILURE_RETRY(close(tempdir_fd));
+      close(tempdir_fd);
     }
   }
   

=== modified file 'plugins.d/mandos-client.xml'
--- plugins.d/mandos-client.xml	2015-03-10 18:52:09 +0000
+++ plugins.d/mandos-client.xml	2016-02-28 14:22:10 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "mandos-client">
-<!ENTITY TIMESTAMP "2015-03-08">
+<!ENTITY TIMESTAMP "2016-02-28">
 <!ENTITY % common SYSTEM "../common.ent">
 %common;
 ]>
@@ -33,9 +33,13 @@
     <copyright>
       <year>2008</year>
       <year>2009</year>
+      <year>2010</year>
+      <year>2011</year>
       <year>2012</year>
       <year>2013</year>
       <year>2014</year>
+      <year>2015</year>
+      <year>2016</year>
       <holder>Teddy Hogeborn</holder>
       <holder>Björn Påhlsson</holder>
     </copyright>
@@ -98,6 +102,10 @@
       </arg>
       <sbr/>
       <arg>
+	<option>--dh-params <replaceable>FILE</replaceable></option>
+      </arg>
+      <sbr/>
+      <arg>
 	<option>--delay <replaceable>SECONDS</replaceable></option>
       </arg>
       <sbr/>
@@ -312,7 +320,26 @@
 	  <para>
 	    Sets the number of bits to use for the prime number in the
 	    TLS Diffie-Hellman key exchange.  The default value is
-	    selected automatically based on the OpenPGP key.
+	    selected automatically based on the OpenPGP key.  Note
+	    that if the <option>--dh-params</option> option is used,
+	    the values from that file will be used instead.
+	  </para>
+	</listitem>
+      </varlistentry>
+      
+      <varlistentry>
+	<term><option>--dh-params=<replaceable
+	>FILE</replaceable></option></term>
+	<listitem>
+	  <para>
+	    Specifies a PEM-encoded PKCS#3 file to read the parameters
+	    needed by the TLS Diffie-Hellman key exchange from.  If
+	    this option is not given, or if the file for some reason
+	    could not be used, the parameters will be generated on
+	    startup, which will take some time and processing power.
+	    Those using servers running under time, power or processor
+	    constraints may want to generate such a file in advance
+	    and use this option.
 	  </para>
 	</listitem>
       </varlistentry>
@@ -445,9 +472,22 @@
   
   <refsect1 id="environment">
     <title>ENVIRONMENT</title>
+    <variablelist>
+      <varlistentry>
+	<term><envar>MANDOSPLUGINHELPERDIR</envar></term>
+	<listitem>
+	  <para>
+	    This environment variable will be assumed to contain the
+	    directory containing any helper executables.  The use and
+	    nature of these helper executables, if any, is
+	    purposefully not documented.
+	</para>
+	</listitem>
+      </varlistentry>
+    </variablelist>
     <para>
-      This program does not use any environment variables, not even
-      the ones provided by <citerefentry><refentrytitle
+      This program does not use any other environment variables, not
+      even the ones provided by <citerefentry><refentrytitle
       >cryptsetup</refentrytitle><manvolnum>8</manvolnum>
     </citerefentry>.
     </para>

=== modified file 'plugins.d/password-prompt.c'
--- plugins.d/password-prompt.c	2014-03-29 02:38:15 +0000
+++ plugins.d/password-prompt.c	2016-02-28 14:22:10 +0000
@@ -2,8 +2,8 @@
 /*
  * Password-prompt - Read a password from the terminal and print it
  * 
- * Copyright © 2008-2014 Teddy Hogeborn
- * Copyright © 2008-2014 Björn Påhlsson
+ * Copyright © 2008-2016 Teddy Hogeborn
+ * Copyright © 2008-2016 Björn Påhlsson
  * 
  * This program is free software: you can redistribute it and/or
  * modify it under the terms of the GNU General Public License as

=== modified file 'plugins.d/password-prompt.xml'
--- plugins.d/password-prompt.xml	2011-12-31 23:05:34 +0000
+++ plugins.d/password-prompt.xml	2016-02-28 14:22:10 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "password-prompt">
-<!ENTITY TIMESTAMP "2012-01-01">
+<!ENTITY TIMESTAMP "2016-02-28">
 <!ENTITY % common SYSTEM "../common.ent">
 %common;
 ]>
@@ -33,8 +33,13 @@
     <copyright>
       <year>2008</year>
       <year>2009</year>
+      <year>2010</year>
       <year>2011</year>
       <year>2012</year>
+      <year>2013</year>
+      <year>2014</year>
+      <year>2015</year>
+      <year>2016</year>
       <holder>Teddy Hogeborn</holder>
       <holder>Björn Påhlsson</holder>
     </copyright>

=== modified file 'plugins.d/plymouth.c'
--- plugins.d/plymouth.c	2014-03-29 02:38:15 +0000
+++ plugins.d/plymouth.c	2016-02-28 14:22:10 +0000
@@ -2,8 +2,8 @@
 /*
  * Plymouth - Read a password from Plymouth and output it
  * 
- * Copyright © 2010-2014 Teddy Hogeborn
- * Copyright © 2010-2014 Björn Påhlsson
+ * Copyright © 2010-2016 Teddy Hogeborn
+ * Copyright © 2010-2016 Björn Påhlsson
  * 
  * This program is free software: you can redistribute it and/or
  * modify it under the terms of the GNU General Public License as

=== modified file 'plugins.d/plymouth.xml'
--- plugins.d/plymouth.xml	2011-12-31 23:05:34 +0000
+++ plugins.d/plymouth.xml	2016-02-28 14:22:10 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "plymouth">
-<!ENTITY TIMESTAMP "2012-01-01">
+<!ENTITY TIMESTAMP "2016-02-28">
 <!ENTITY % common SYSTEM "../common.ent">
 %common;
 ]>
@@ -34,6 +34,10 @@
       <year>2010</year>
       <year>2011</year>
       <year>2012</year>
+      <year>2013</year>
+      <year>2014</year>
+      <year>2015</year>
+      <year>2016</year>
       <holder>Teddy Hogeborn</holder>
       <holder>Björn Påhlsson</holder>
     </copyright>

=== modified file 'plugins.d/splashy.c'
--- plugins.d/splashy.c	2014-03-29 02:38:15 +0000
+++ plugins.d/splashy.c	2016-02-28 14:22:10 +0000
@@ -2,8 +2,8 @@
 /*
  * Splashy - Read a password from splashy and output it
  * 
- * Copyright © 2008-2014 Teddy Hogeborn
- * Copyright © 2008-2014 Björn Påhlsson
+ * Copyright © 2008-2016 Teddy Hogeborn
+ * Copyright © 2008-2016 Björn Påhlsson
  * 
  * This program is free software: you can redistribute it and/or
  * modify it under the terms of the GNU General Public License as

=== modified file 'plugins.d/splashy.xml'
--- plugins.d/splashy.xml	2011-12-31 23:05:34 +0000
+++ plugins.d/splashy.xml	2016-02-28 14:22:10 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "splashy">
-<!ENTITY TIMESTAMP "2012-01-01">
+<!ENTITY TIMESTAMP "2016-02-28">
 <!ENTITY % common SYSTEM "../common.ent">
 %common;
 ]>
@@ -33,7 +33,13 @@
     <copyright>
       <year>2008</year>
       <year>2009</year>
+      <year>2010</year>
+      <year>2011</year>
       <year>2012</year>
+      <year>2013</year>
+      <year>2014</year>
+      <year>2015</year>
+      <year>2016</year>
       <holder>Teddy Hogeborn</holder>
       <holder>Björn Påhlsson</holder>
     </copyright>

=== modified file 'plugins.d/usplash.c'
--- plugins.d/usplash.c	2014-03-29 02:38:15 +0000
+++ plugins.d/usplash.c	2016-02-28 14:22:10 +0000
@@ -2,8 +2,8 @@
 /*
  * Usplash - Read a password from usplash and output it
  * 
- * Copyright © 2008-2014 Teddy Hogeborn
- * Copyright © 2008-2014 Björn Påhlsson
+ * Copyright © 2008-2016 Teddy Hogeborn
+ * Copyright © 2008-2016 Björn Påhlsson
  * 
  * This program is free software: you can redistribute it and/or
  * modify it under the terms of the GNU General Public License as
@@ -117,7 +117,7 @@
       ret = asprintf(&cmd_line_alloc, "%s %s", cmd, arg);
       if(ret == -1){
 	int e = errno;
-	TEMP_FAILURE_RETRY(close(*fifo_fd_r));
+	close(*fifo_fd_r);
 	errno = e;
 	return false;
       }
@@ -133,7 +133,7 @@
 		 cmd_line_len - written);
     if(sret == -1){
       int e = errno;
-      TEMP_FAILURE_RETRY(close(*fifo_fd_r));
+      close(*fifo_fd_r);
       free(cmd_line_alloc);
       errno = e;
       return false;
@@ -491,7 +491,7 @@
 	error_plus(0, errno, "read");
 	status = EX_OSERR;
       }
-      TEMP_FAILURE_RETRY(close(outfifo_fd));
+      close(outfifo_fd);
       goto failure;
     }
     if(interrupted_by_signal){
@@ -578,7 +578,7 @@
   
   /* Close FIFO */
   if(fifo_fd != -1){
-    ret = (int)TEMP_FAILURE_RETRY(close(fifo_fd));
+    ret = close(fifo_fd);
     if(ret == -1 and errno != EINTR){
       error_plus(0, errno, "close");
     }
@@ -587,7 +587,7 @@
   
   /* Close output FIFO */
   if(outfifo_fd != -1){
-    ret = (int)TEMP_FAILURE_RETRY(close(outfifo_fd));
+    ret = close(outfifo_fd);
     if(ret == -1){
       error_plus(0, errno, "close");
     }
@@ -655,7 +655,7 @@
   
   /* Close FIFO (again) */
   if(fifo_fd != -1){
-    ret = (int)TEMP_FAILURE_RETRY(close(fifo_fd));
+    ret = close(fifo_fd);
     if(ret == -1 and errno != EINTR){
       error_plus(0, errno, "close");
     }

=== modified file 'plugins.d/usplash.xml'
--- plugins.d/usplash.xml	2011-12-31 23:05:34 +0000
+++ plugins.d/usplash.xml	2016-02-28 14:22:10 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "usplash">
-<!ENTITY TIMESTAMP "2012-01-01">
+<!ENTITY TIMESTAMP "2016-02-28">
 <!ENTITY % common SYSTEM "../common.ent">
 %common;
 ]>
@@ -33,8 +33,13 @@
     <copyright>
       <year>2008</year>
       <year>2009</year>
+      <year>2010</year>
       <year>2011</year>
       <year>2012</year>
+      <year>2013</year>
+      <year>2014</year>
+      <year>2015</year>
+      <year>2016</year>
       <holder>Teddy Hogeborn</holder>
       <holder>Björn Påhlsson</holder>
     </copyright>

